@echo off
setlocal ENABLEEXTENSIONS EnableDelayedExpansion

REM $Id: standalone_dll.bat 8889 2016-03-11 15:48:34Z hstrauss $
REM
REM Copyright (c) IMACS GmbH, Germany. All rights reserved.

REM Copies the DLL files in the standalone directory

SET TARGET=%~1

copy "%windir%\system32\mfc70.dll" "%TARGET%" /Y >NUL 2>NUL
copy "%windir%\system32\msvcp70.dll" "%TARGET%" /Y >NUL 2>NUL
copy "%windir%\system32\msvcr70.dll" "%TARGET%" /Y >NUL 2>NUL
copy "%windir%\system32\mfc70u.dll" "%TARGET%" /Y >NUL 2>NUL

if not exist ..\sim\sim.sln goto NOSIMSLN

rem File format version of solution does NOT equal visual studio version
set VSVERS=
findstr /m /c:"Microsoft Visual Studio Solution File, Format Version 9.00" ..\sim\sim.sln >NUL 2>NUL
if !errorlevel!==0 set VSVERS=8.0
findstr /m /c:"Microsoft Visual Studio Solution File, Format Version 10.00" ..\sim\sim.sln >NUL 2>NUL
if !errorlevel!==0 set VSVERS=9.0
findstr /m /c:"Microsoft Visual Studio Solution File, Format Version 11.00" ..\sim\sim.sln >NUL 2>NUL
if !errorlevel!==0 set VSVERS=10.0
findstr /m /c:"Microsoft Visual Studio Solution File, Format Version 12.00" ..\sim\sim.sln >NUL 2>NUL
if !errorlevel!==0 (
  findstr /m /c:"<PlatformToolset>v110" ..\sim\sim.vcxproj >NUL 2>NUL
  if !errorlevel!==0 set VSVERS=11.0
  findstr /m /c:"<PlatformToolset>v120" ..\sim\sim.vcxproj >NUL 2>NUL
  if !errorlevel!==0 set VSVERS=12.0
  findstr /m /c:"<PlatformToolset>v140" ..\sim\sim.vcxproj >NUL 2>NUL
  if !errorlevel!==0 set VSVERS=14.0
)

if "!VSVERS!"=="" goto VSUNKNOWN

rem Delete old MSVC_BIN if any
set MSVC_BIN=
call "%OSDL_SYS%\ctr_lib\arg_batches\set_msvc_bin.bat" !VSVERS!

if "!MSVC_BIN!"=="" goto VSSLNNOTINSTALLED

rem Don't copy for VS2008 because the files are already there, because Common is
rem compiled with VS2008 SP1. If we copy the files, it could cause errors if the
rem customer doesn't have installed Service Pack 1, so to prevent errors, only
rem copy files for all other Visual Studio versions
if not "!VSVERS!"=="9.0" (
	rem Check if redist directory exists
	pushd.
	cd "!MSVC_BIN!\..\redist\x86\Microsoft.VC!VSVERS:.=!.CRT" >NUL 2>NUL
	if errorlevel 1 (
		rem Try copying with wildcard from system32 this should work for VS2010 Express
		rem there is currently no other installation known without redist directory
		rem For future versions of VS the Express versions have to be checked if
		rem directory exists and if not, if this solution will still work
		copy "%WINDIR%\System32\*!VSVERS:.=!.dll" "%TARGET%" /Y >NUL 2>NUL
	)
	popd
	copy "!MSVC_BIN!\..\redist\x86\Microsoft.VC!VSVERS:.=!.CRT\*.*" "%TARGET%" /Y >NUL 2>NUL
)

if "!VSVERS!"=="14.0" (
	call :GETSDK10INSTALLPATH SdkInstallPath
    copy "!SdkInstallPath!\Redist\ucrt\DLLs\x86\*.*" "%TARGET%" /Y >NUL 2>NUL
)

goto END

:VSSLNNOTINSTALLED
echo error: Could not find installation of Visual Studio !VSVERS! required for sim.sln
goto ERROR

:VSUNKNOWN
echo error: Could not determine version of sim.sln solution. Corrupted file or unsupported version?
goto ERROR

:ERROR
pause
endlocal
exit /b 1

:END
exit /b 0
endlocal

:GETSDK10INSTALLPATH
for %%a in (SOFTWARE\Microsoft\ SOFTWARE\Wow6432Node\Microsoft\) do (
	set KEY_NAME="HKEY_LOCAL_MACHINE\%%aMicrosoft SDKs\Windows\v10.0"
	for /F "usebackq tokens=2*" %%b in (`REG QUERY !KEY_NAME! /v InstallationFolder 2^>nul`) do (
		set "%~1=%%c"
	)
)
goto :EOF