//
// $Id: ctr_bas.h 9097 2016-07-08 10:16:14Z wdaur $
//
// Copyright (c) IMACS GmbH Germany. All rights reserved.
//

#ifndef __CTR_BAS_H__
#define __CTR_BAS_H__

#include <cominterface.h>

#define		RD_size		unsigned short
#define		RD_COLOR	unsigned char

// format of one hmi pixel 
#if BITSPERPIXEL <= 8
#define RD_XCOLOR		unsigned char
#else
#if BITSPERPIXEL <= 16
#define RD_XCOLOR		unsigned short
#else
#define RD_XCOLOR		unsigned long
#endif
#endif

// Wenn die PC-Simulation mehrere Target-HMI's zugleich zulaesst :
// dafuer muessen allen Funktionen fuer Displayausgabe einen Zeiger auf ein Displayhandel erhalten
// diese werden ueber folgenden Macros realisiert (um nicht alle Funktionen zweimal definieren zu muessen)
#ifndef ___CTR___
	#define M_D_SCR		EMB_HMI RD_MROM *screen,
	#define M_D_SCR_KV	,EMB_HMI RD_MROM *screen
	#define M_D_SCR_S	EMB_HMI RD_MROM *screen
	#ifndef RD_NO_COLOR
		#define M_D_SCRCOL_S    EMB_HMI RD_MROM *screen, RD_COLOR col
		#define M_SCRCOL        screen, col
	#else // RD_NO_COLOR
		#define M_D_SCRCOL_S    EMB_HMI RD_MROM *screen
		#define M_SCRCOL        screen
	#endif // RD_NO_COLOR
	#define M_SCR		screen
	#define M_SCR_K		screen,
	#define M_SCR_KV	,screen
	#define M_D_SRC_NODE	short sourceNode,	// bei indizierter Event-Kommunikation
	#define M_SRC_NODE(sourceNode)	sourceNode,	// bei indizierter Event-Kommunikation


	#define	M_D_HMIID		short hmiID
	#define	M_D_HMIID_KV	,short hmiID
	#define	M_HMIID			hmiID
	#define	M_HMIID_KV		,hmiID
	#define	M_S_HMIID		screen->screenID
	#define	M_S_HMIID_KV	,screen->screenID
	#define	M_HMIID_A		screen->screenID


#else
	#define M_D_SCR
	#define M_D_SCR_KV
	#define M_D_SCR_S		void
	#ifndef RD_NO_COLOR
		#define M_D_SCRCOL_S    RD_COLOR col
		#define M_SCRCOL        col
	#else // RD_NO_COLOR
		#define M_D_SCRCOL_S    void
		#define M_SCRCOL        
	#endif // RD_NO_COLOR
	#define M_SCR
	#define M_SCR_K
	#define M_SCR_KV
	#define M_D_SRC_NODE
	#define M_SRC_NODE(sourceNode)

	#define	M_D_HMIID	void
	#define	M_D_HMIID_KV
	#define	M_HMIID
	#define	M_HMIID_KV
	#define	M_S_HMIID
	#define	M_S_HMIID_KV
	#define	M_HMIID_A		0
#endif

// control the option "without colour support"
#ifndef RD_NO_COLOR
	#define M_D_COL			,RD_COLOR	col
	#define M_D_COLBK		,RD_COLOR	colbk
	#define M_D_COL_KV		RD_COLOR	col
	#define M_D_COLBK_KV	RD_COLOR	colbk
	#define M_COL			,col
	#define M_COLBK			,colbk
	#define M_COL_KV		col
	#define M_COLBK_KV		colbk
	#define	M_S_COL			,RDCOL
	#define	M_S_COLBK		,RDCOLBK
	#define	M_S_COLPIC		,RDCOLPIC
	#define	M_S_COLNON		,RDCOLNON
	#define	M_A_COL(a)		,a	
	#define	M_REPL_COL		,col
	#define	M_RD_EditCol	,RD_EditCol	
	#define	M_RD_EditColBk	,RD_EditColBk	
#else
	#define M_D_COL
	#define M_D_COLBK
	#define M_D_COL_KV		
	#define M_D_COLBK_KV	
	#define M_COL
	#define M_COLBK
	#define M_COL_KV
	#define M_COLBK_KV
	#define	M_S_COL	
	#define	M_S_COLBK
	#define	M_S_COLPIC
	#define	M_S_COLNON
	#define	M_A_COL(a)
	#define	M_REPL_COL	,RDCOL
	#define	M_RD_EditCol	
	#define	M_RD_EditColBk	
#endif

#if RD_DMINELEMDESC != 0
#define M_MODPNTINELEM(modpnt) ,modpnt
#else
#define M_MODPNTINELEM(modpnt)
#endif


//*** the value type used in actions
#define RD_VALUE long

//*** Unicode-Behandlung
#if (RD_USE_TTFFONTS == 0)
#define	MAX_SMALLFONT_CHAR	0x800		// groesstes Zeichen das keinen grafischen Font erfordert
#endif

#if RD_UNICODESETTING == 0					// ASCII
	typedef char RD_char;					// character (for handling)
	typedef char RD_pchar;					// character (for print and edit) 
// conversion of ASCII strings into string format according to RD_UNICODESETTING and vice versa
// Conversion Macros (for every UNICODESETTING)
	#define	CHAR2UNI(a)		(a)					// here all dummy functions
	#define	STR2UNI(a)		(a)
	#define	STRS2UNI(a,b)	(a)
	#define	UNI2CHAR(a)		(a)
	#define	UNI2STR(a,b)	(a)
#endif
#if RD_UNICODESETTING == 1					// UNICODE (all characters are 16bit wide)
	typedef unsigned short RD_char;			// character (for handling)
	typedef unsigned short RD_pchar;		// character (for print and edit) 
// conversion of ASCII strings into string format according to RD_UNICODESETTING and vice versa
	RD_char RD_MRAM  char2uni(char RD_MRAM c);
	RD_char RD_MRAM *str2uni(char RD_MRAM *str);
	char RD_MRAM uni2char(RD_char RD_MRAM c);
	char RD_MRAM * uni2str(RD_char RD_MRAM *str, char RD_MRAM * acstr);
// Conversion Macros (for every UNICODESETTING)
	#define	CHAR2UNI(a)		char2uni(a)		// convert one char to a uncode char
	#define	STR2UNI(a)		str2uni(a)		// legacy version of STRS2UNI, not reentrant, do not use for new designs !
	#define	STRS2UNI(a,b)	strs2uni(a,b)	// convert an ASCII string to a UNICODE string
	#define	UNI2CHAR(a)		uni2char(a)		// convert one UNICODE char into ASCII. in case the char is not representable in ASCII, Blank (0x020) is returned
	#define	UNI2STR(a,b)	uni2str(a,b)	// string conversion Unicode->ASCII. chars not representable in ASCII are replaced by Blank (0x20)
#endif
#if RD_UNICODESETTING == 2					// UTF-8 (1..3 bytes per char)
	typedef char RD_char;					// character (for handling)
	typedef unsigned short RD_pchar;		// character (for print and edit, use Unicode if UTF8)
// conversion of ASCII strings into string format according to RD_UNICODESETTING and vice versa
	short utf2uni(char RD_MRAM *in, unsigned short RD_MRAM *out);
	short uni2utf(unsigned short RD_MRAM *in, char RD_MRAM *out);
	void  strutf2uni(char RD_MRAM *in, unsigned short RD_MRAM *out, RD_size maxbufsize);
	short struni2utf(unsigned short RD_MRAM *in, char RD_MRAM *out, RD_size maxbufsize);
	char RD_MRAM * utf2str(RD_char RD_MRAM *str, char RD_MRAM * acstr);
// Conversion Macros (for every UNICODESETTING)
	#define	CHAR2UNI(a)		(a)				// convert one char to a UTF-8 char, ASCII is always converted to a 1 byte UTF char
	#define	STR2UNI(a)		(a)				// legacy version of STRS2UNI, do not use for new designs !
	#define	STRS2UNI(a,b)	(a)				// convert an ASCII string to a UTF-8 string, ASCII is always converted to a 1 byte UTF char
	#define	UNI2CHAR(a)		(a)				// convert one UTF-8 char into ASCII. Does not really work for all UTF-8 chars, suitable only for 1-byte-chars < 0x80, for full conversion a direct call to utf2uni() must be used
	#define	UNI2STR(a,b)	utf2str(a,b)	// string conversion UTF->ASCII. chars not representable in ASCII are replaced by Blank (0x20)
#endif


#if ((DISP_GRA != 0) && (RD_UNICODESETTING != 0))
	#define RD_DYNAMIC_FONT 	1
#endif	


void    RdStackCheck(unsigned short);
void    showMarkedFlags(M_D_SCR_S); 
void	doSetup(M_D_SCR_S);
void    SysInit(M_D_SCR_S);
void	SetLanguageSelection(void);


#define	STKCHK_VIS_INITNEWSUR	1
#define	STKCHK_VIS_DOSURINT		2
#define	STKCHK_UTIL_DOACTION	3
#define	STKCHK_CE_EDITNUM		101
#define	STKCHK_CE_EDITBIN		102
#define	STKCHK_CE_EDITSTR		103
#define	STKCHK_CE_EDITDAT		104
#define	STKCHK_CE_EDITTIM		105
#define	STKCHK_CE_EDITMULTI		106


#define	PARSER_NO_REF		0
#define PARSER_DESC_MODUL 	1
#define PARSER_DESC_SURFACE	2
#define PARSER_UNKNOWN		3
#define PARSER_DESC_ELEMENT	4
#define PARSER_VALUE_ELEMENT	5
#define PARSER_USER_LABEL     6

short searchPlaceholder(RD_char RD_MRAM *str, int RD_MRAM *pos);
void replacePlaceholder(RD_char RD_MRAM *str, int posPlaceholder, RD_char RD_MRAM *replacement);


// *************************************************************************
// Functions
// *************************************************************************

#define	char2str(src,dr,form)	 value2str((long)(src), (dr), (form), 1)
#define	uchar2str(src,dr,form)	 value2str((long)(src), (dr), (form),-1)
#define	short2str(src,dr,form)	 value2str((long)(src), (dr), (form), 2)
#define	ushort2str(src,dr,form)	 value2str((long)(src), (dr), (form),-2)
#define	long2str(src,dr,form)	 value2str((long)(src), (dr), (form), 4)
#define	ulong2str(src,dr,form)	 value2str((long)(src), (dr), (form),-4)

void	value2str(long,				RD_char RD_MRAM *drain, short format, short size);
void	long2hexstr(unsigned long,	RD_char RD_MRAM *drain, short format);
void	date2str(long, 				RD_char RD_MRAM *drain, char mode);
void	time2str(long, 				RD_char RD_MRAM *drain, char mode);

void	str2int(RD_char RD_MRAM *, short RD_MRAM *, RD_size);
void	str2long(RD_char RD_MRAM *, long RD_MRAM *, RD_size);
void	hexstr2long(RD_char RD_MRAM *, unsigned long RD_MRAM *, RD_size);
void	str2date(RD_char RD_MRAM *, long RD_MRAM *time);
void	str2time(RD_char RD_MRAM *, long RD_MRAM *time);

#if RD_USEFLOAT != 0
	float	str2float(RD_char RD_MRAM *);
	void 	RD_sprintf(RD_char *buffer,RD_CONST char *format , void* );
#endif

short	c_timtest(long timeval);
short	c_dattest(long dateval);
short	c_time_test(long timeval);

//**************

void	DebugMsg(RD_CONST char* pszFormat, ...);

void	RD_MBIN *adr2ptr(long);
long	ptr2adr(void RD_MBIN *); // bspw. in usercode.c als Aufruf ueber PTR_2_ADR


void 	RD_saveSysDateTime(long date, long time);
void 	RD_updateSysDateTime(void);
short	RD_getSystemDayOfWeek(unsigned long date);

void	put_checksum(unsigned long, unsigned long);
short	get_checksum(unsigned long, unsigned long);

void	cardPerm(void);
short	cardReadData(void RD_MRAM *Zielzeiger, short Kartenadresse, short AnzahlBytes);

//***************

void    RD_strfill(RD_char RD_MRAM *, RD_char, RD_size);
void    RD_strcpylim(RD_char RD_MRAM *, RD_char RD_MRAM *, RD_size);
void    RD_strcatlim(RD_char RD_MRAM *, RD_char RD_MRAM *, RD_size);
void    RD_strexp(RD_char RD_MRAM *, RD_size);
	
short 	RD_strChkSmallChar(RD_char RD_MRAM *str);
void	RD_strpixsize(RD_char RD_MRAM *str, short *w, short *h);


#if RD_UNICODESETTING == 1
	//*** falls Unicode => radCASE-interne Routinen verwenden
	RD_char RD_MRAM *RD_strtok(RD_char RD_MRAM *str1, RD_char RD_MRAM *str2);
	short	         RD_strlen(RD_char RD_MRAM *str);
	RD_char RD_MRAM *RD_strcat(RD_char RD_MRAM *str1, RD_char RD_MRAM *str2);
	RD_char RD_MRAM *RD_strcpy(RD_char RD_MRAM *str1, RD_char RD_MRAM *str2);
	RD_char RD_MRAM *RD_strncpy(RD_char RD_MRAM *str1, RD_char RD_MRAM *str2,  RD_size);
	short	         RD_strcmp(RD_char RD_MRAM *str1, RD_char RD_MRAM *str2);
	short	         RD_strncmp(RD_char RD_MRAM *str1, RD_char RD_MRAM *str2,  RD_size);
	RD_char RD_MRAM *RD_strchr(RD_char RD_MRAM *str1, short chr);

	#define RD_strlen16(a)    RD_strlen(a)
#else
	//*** sonst die Funktionen der C-Standard-Libraries verwenden
	#define	RD_strtok(a,b)	  strtok(a,b)
	#define RD_strlen(a)      (short)strlen(a)
	#define RD_strcat(a,b)    strcat(a,b)
	#define RD_strcpy(a,b)    strcpy(a, (const char *) b)
	#define RD_strncpy(a,b,c) strncpy(a,b,c)
	#define RD_strcmp(a,b)    strcmp(a,b)
	#define RD_strncmp(a,b,c) strncmp(a,b,c)
	#define RD_strchr(a,b)    strchr(a,b)

	#if RD_UNICODESETTING != 2
		#define RD_strlen16(a)    strlen(a)
	#else
		short	RD_strlen16(RD_pchar RD_MRAM *str);
		short 	RD_strused(RD_char RD_MRAM *str);
	#endif
#endif

void	c_print(M_D_SCR short sx, short sy, RD_char RD_MRAM *str M_D_COL M_D_COLBK, short maxlen);
void	c_print_char(M_D_SCR short, short, RD_char										M_D_COL M_D_COLBK);
void	c_print_int(M_D_SCR short, short, short, short									M_D_COL M_D_COLBK);
void	c_print_long(M_D_SCR short, short, long, short									M_D_COL M_D_COLBK);
void	c_print_strl(M_D_SCR short, short, RD_char RD_MRAM *, short						M_D_COL M_D_COLBK);
void	c_print_str(M_D_SCR short, short, RD_char RD_MRAM *								M_D_COL M_D_COLBK);
void	c_print_strlim(M_D_SCR short, short, RD_char RD_MRAM *, unsigned short			M_D_COL M_D_COLBK);
void	c_print_strlim16(M_D_SCR short, short, RD_pchar RD_MRAM *, unsigned short		M_D_COL M_D_COLBK);
void	c_print_dat(M_D_SCR short, short, long											M_D_COL M_D_COLBK);
void	c_print_tim(M_D_SCR short, short, long, char									M_D_COL M_D_COLBK);
void	c_print_mask(M_D_SCR unsigned char RD_MRAM *);	

void	c_print_short_hex(M_D_SCR short x, short y, unsigned short value, short digits	M_D_COL M_D_COLBK);
void	c_print_long_hex(M_D_SCR short x, short y,  unsigned long  value, short digits	M_D_COL M_D_COLBK);

void	c_print_stridx(M_D_SCR short text, short x, short y);
void	c_print_stridxl(M_D_SCR short text, short x, short y, RD_size len);

void	c_scr_clear(short, short, short, short											M_D_COL M_D_COLBK);
short	c_scr_init(unsigned short, unsigned short, unsigned short);

void	c_win_paint(short, short, short, short											M_D_COL M_D_COLBK);
void	c_win_save(short, short, short, short);
void	c_win_restore(void);

short	c_enter_num(M_D_SCR short, short, long RD_MRAM *, short, long min, long max, unsigned char, unsigned char);
short	c_enter_dat(M_D_SCR short, short, long RD_MRAM *, unsigned char, unsigned char);
short	c_enter_tim(M_D_SCR short, short, long RD_MRAM *, short, unsigned char, unsigned char);
short	c_enter_sel(M_D_SCR short, short, short RD_MRAM *, short, char RD_MRAM *);

extern	short 	_f_toggle_num;
extern	short 	_f_toggle_str;
extern	void	*_ed_mem_base;
extern 	void	(*c_edit_num_err)(long, long, short, short);


//*** interne Testroutinen ********
void	printbits(M_D_SCR short wert);
RD_char RD_MRAM *RD_getstr(XPTR index, RD_char RD_MRAM *buf);
void	debugPtr(M_D_SCR void RD_MRAM *ptr);
void	debugfarPtr(void RD_MBIN *ptr);
void	resetAbort(void);


//*** Diagnose/Kalibrierung
short	diag_di(M_D_SCR_S);
short	diag_do(M_D_SCR_S);
short	diag_ai(M_D_SCR_S);
short	diag_ao(M_D_SCR_S);
short	diag_cnt(M_D_SCR_S);
short	kali_cnt(M_D_SCR_S);
short	kali_ai(M_D_SCR_S);
short	kali_ao(M_D_SCR_S);

short	cFuncProtokoll(M_D_SCR_S);
short	cFuncRtcSet(M_D_SCR unsigned char mode);
short	cFuncAskOk(M_D_SCR_S);
short	cFuncAskOk2(M_D_SCR_S);
short	cFuncAskDel(M_D_SCR_S);
short	cFuncAskForce(M_D_SCR_S);



short	cFuncUserRedraw(M_D_SCR_S);

short	cFuncProcSetup(void);	//** aktuelle Daten auf Standardwert setzen
short	cFuncProcRestore(void);	//** Daten auf remanenten Speicher rueckkopieren

short	cFuncParCopy(void);		//** aktuelle Daten auf Editierkopie kopieren
short	cFuncParRestore(void);	//** Editiertkopie auf aktuelle Daten und remanenten Speicher rueckkopieren
short	cFuncParSetup(void);	//** aktuelle Daten auf Standardwert setzen

short	cFuncSysCopy(void);		//** aktuelle Daten auf Editierkopie kopieren
short	cFuncSysRestore(void);	//** Editiertkopie auf aktuelle Daten und remanenten Speicher rueckkopieren
short	cFuncSysSetup(void);	//** aktuelle Daten auf Standardwert setzen

short	cFuncKaliCopy(void);	//** aktuelle Daten auf Editierkopie kopieren
short	cFuncKaliRestore(void);	//** Editiertkopie auf aktuelle Daten und remanenten Speicher  rueckkopieren
short	cFuncKaliSetup(void);	//** aktuelle Daten auf Standardwert setzen

short	cFuncRemaSetup(void);	//** aktuelle Daten auf Standardwert setzen
short	cFuncRemaRestore(void);	//** Daten auf remanenten Speicher rueckkopieren

short	cFuncTouchSetup(void);	//** aktuelle Daten auf spezifischen Standardwert setzen
short	cFuncTouchRestore(void);//** Daten auf remanenten Speicher rueckkopieren

short	cFuncCalSet(void);
short	cFuncCalRes(void);

short	eepCheckBlk(void RD_MRAM *mem, short size, short vers, short checksumcheck);

void	eepBlkPrep(unsigned char RD_MRAM *mem, short size, short version);

// SD Card Interface

extern void sdGetInfo(struct sdInfo* info);
extern short sdOpenFile(char* filename,short mode);
extern void sdCloseFile(void);
extern short sdReadData(char* filename, char* dstAddr, unsigned short nBytes);
extern short sdReadSomeData(char* dstAddr, unsigned short nBytes);
extern short sdGetc(char* dstAddr);
extern short sdWriteData(char* filename, char* srcAdr, unsigned short nBytes, short mode);
extern short sdWriteSomeData(char* srcAdr, unsigned short nBytes);
extern long sdFileSize(char* filename);
extern short sdCreateFolder(char* foldername);
extern short sdFileExists(char* filename);
extern void sdGetLine(RD_char * buf, short size);
extern void sdPutLine(RD_char * buf);
extern short sdGetDirListing(char* filename, short bufsize, unsigned short openNewList);

short	cFuncPar2Card(M_D_SCR_S);
short	cFuncCard2Par(M_D_SCR_S);
short	cFuncSys2Card(M_D_SCR_S);
short	cFuncCard2Sys(M_D_SCR_S);
short	cFuncKali2Card(M_D_SCR_S);
short	cFuncCard2Kali(M_D_SCR_S);
short	cFuncFormatCard(M_D_SCR_S);
short	cFuncGetCardDir(M_D_SCR_S);

short	cFuncKonfProt(M_D_SCR_S);	// Konfiguriere die Protokolldaten
short	cFuncProtPwd(M_D_SCR_S);
short	cFuncWarnAskOk(M_D_SCR_S);

short	cFuncSingleDI(M_D_SCR_S);
short	cFuncSwitchDO(M_D_SCR_S);

short	cFuncIOReset(void);
void	cFuncUnForce(void);



// *************************************************************************
// Interfacefunktionen zu einem RTOS
// *************************************************************************
#ifdef ___CTR___
	typedef	short	RD_SEMA;			// Abhaengig von Betriebssystem
	typedef	short	RD_MAIL;			// Abhaengig von Betriebssystem
	typedef	short	RD_EVENT;			// Abhaengig von Betriebssystem
#else
	typedef	HANDLE	RD_SEMA;			// Abhaengig von Betriebssystem
	typedef	HANDLE	RD_MAIL;			// Abhaengig von Betriebssystem
	typedef	HANDLE	RD_EVENT;			// Abhaengig von Betriebssystem
#endif

RD_SEMA RDSemaCreate(RD_SEMA Semaxyz, short initval);		// initval von SV=1 
void RDSemaPut(RD_SEMA Semaxyz);
short RDSemaStat(RD_SEMA Semaxyz);	// holt status (0..x) ohne zu leeren ohne zu warten
short RDSemaGet(RD_SEMA Semaxyz);	// holt 1 inhalt ohne warten mit leeren

short RDSemaWait(RD_SEMA Semaxyz);	// versucht einen inhalt zu holen mit warten (und gg. suspend)
short RDSemaWaitT(RD_SEMA Semaxyz, short time);

RD_MAIL RDMailCreate(RD_MAIL Semaxyz, short initval);		// initval von SV=1 
void RDMailPut(RD_MAIL Semaxyz);
short RDMailStat(RD_MAIL Semaxyz);	// holt status (0..x) ohne zu leeren ohne zu warten
short RDMailGet(RD_MAIL Semaxyz);	// holt 1 inhalt ohne warten mit leeren

short RDMailWait(RD_MAIL Semaxyz);	// versucht einen inhalt zu holen mit warten (und gg. suspend)
short RDMailWaitT(RD_MAIL Semaxyz, short time);

RD_EVENT RDEventCreate(RD_EVENT Semaxyz, short initval);		// initval von SV=1 
void RDEventPut(RD_EVENT Semaxyz);
short RDEventStat(RD_EVENT Semaxyz);	// holt status (0..x) ohne zu leeren ohne zu warten
short RDEventGet(RD_EVENT Semaxyz);	    // holt 1 inhalt ohne warten mit leeren

short RDEventWait(RD_EVENT Semaxyz);	// versucht einen inhalt zu holen mit warten (und gg. suspend)
short RDEventWaitT(RD_EVENT Semaxyz, short time);

void RDEvtPutByte(unsigned char RD_MRAM *elemAct, unsigned char val);
unsigned char RDEvtStatByte(unsigned char RD_MRAM *elemAct);
unsigned char RDEvtGetByte(unsigned char RD_MRAM *elemAct);

void RDEvtPutChar(char RD_MRAM *elemAct, char val);
char RDEvtStatChar(char RD_MRAM *elemAct);
char RDEvtGetChar(char RD_MRAM *elemAct);

void RDEvtPutShort(short RD_MRAM *elemAct, short val);
short RDEvtStatShort(short RD_MRAM *elemAct);
short RDEvtGetShort(short RD_MRAM *elemAct);

void RDEvtPutLong(long RD_MRAM *elemAct, long val);
long RDEvtStatLong(long RD_MRAM *elemAct);
long RDEvtGetLong(long RD_MRAM *elemAct);

void RDEvtPutUShort(unsigned short RD_MRAM *elemAct, unsigned short val);
unsigned short RDEvtStatUShort(unsigned short RD_MRAM *elemAct);
unsigned short RDEvtGetUShort(unsigned short RD_MRAM *elemAct);

void RDEvtPutULong(unsigned long RD_MRAM *elemAct, unsigned long val);
unsigned long RDEvtStatULong(unsigned long RD_MRAM *elemAct);
unsigned long RDEvtGetULong(unsigned long RD_MRAM *elemAct);

#if RD_USEFLOAT != 0
	void RDEvtPutFloat(float RD_MRAM *elemAct, float val);
	void RDEvtPutDouble(double RD_MRAM *elemAct, double val);
#endif


void InitSemaphore(void);
void PermSemaphore(void);

void ResetAbortTimer(void);

extern short IO_Init;



// *************************************************************************
// Funktionen fuer die eventgetriggerte Kommunktion in verteilten Systemen
// OHNE Quellenkennung
// *************************************************************************

// aufgerufen bei Veraenderung von EBIN, ENUM falls vom Umfang char bzw. unsigned char
void RDWrEvt1UChar(M_D_SRC_NODE short Node, unsigned short index, unsigned char value);
void RDWrEvt1Char(M_D_SRC_NODE short Node, unsigned short index, char value);
void RDWrEvt2UChar(M_D_SRC_NODE short Node, unsigned short index, unsigned char value);
void RDWrEvt2Char(M_D_SRC_NODE short Node, unsigned short index, char value);
void RDWrEvt3UChar(M_D_SRC_NODE short Node, unsigned short index, unsigned char value);
void RDWrEvt3Char(M_D_SRC_NODE short Node, unsigned short index, char value);
void RDWrEvt4UChar(M_D_SRC_NODE short Node, unsigned short index, unsigned char value);
void RDWrEvt4Char(M_D_SRC_NODE short Node, unsigned short index, char value);
void RDWrEvt5UChar(M_D_SRC_NODE short Node, unsigned short index, unsigned char value);
void RDWrEvt5Char(M_D_SRC_NODE short Node, unsigned short index, char value);
void RDWrEvt6UChar(M_D_SRC_NODE short Node, unsigned short index, unsigned char value);
void RDWrEvt6Char(M_D_SRC_NODE short Node, unsigned short index, char value);
void RDWrEvt7UChar(M_D_SRC_NODE short Node, unsigned short index, unsigned char value);
void RDWrEvt7Char(M_D_SRC_NODE short Node, unsigned short index, char value);
void RDWrEvt8UChar(M_D_SRC_NODE short Node, unsigned short index, unsigned char value);
void RDWrEvt8Char(M_D_SRC_NODE short Node, unsigned short index, char value);
void RDWrEvtEdUChar(M_D_SRC_NODE short Node, unsigned short index, unsigned char value);
void RDWrEvtEdChar(M_D_SRC_NODE short Node, unsigned short index, char value);

//* aufgerufen bei Veraenderung von EBIN, ENUM falls vom Umfang short bzw. unsigned short 
void RDWrEvt1UShort(M_D_SRC_NODE short Node ,unsigned short index, unsigned short value);
void RDWrEvt1Short(M_D_SRC_NODE short Node ,unsigned short index, short value);
void RDWrEvt2UShort(M_D_SRC_NODE short Node ,unsigned short index, unsigned short value);
void RDWrEvt2Short(M_D_SRC_NODE short Node ,unsigned short index, short value);
void RDWrEvt3UShort(M_D_SRC_NODE short Node ,unsigned short index, unsigned short value);
void RDWrEvt3Short(M_D_SRC_NODE short Node ,unsigned short index, short value);
void RDWrEvt4UShort(M_D_SRC_NODE short Node ,unsigned short index, unsigned short value);
void RDWrEvt4Short(M_D_SRC_NODE short Node ,unsigned short index, short value);
void RDWrEvt5UShort(M_D_SRC_NODE short Node ,unsigned short index, unsigned short value);
void RDWrEvt5Short(M_D_SRC_NODE short Node ,unsigned short index, short value);
void RDWrEvt6UShort(M_D_SRC_NODE short Node ,unsigned short index, unsigned short value);
void RDWrEvt6Short(M_D_SRC_NODE short Node ,unsigned short index, short value);
void RDWrEvt7UShort(M_D_SRC_NODE short Node ,unsigned short index, unsigned short value);
void RDWrEvt7Short(M_D_SRC_NODE short Node ,unsigned short index, short value);
void RDWrEvt8UShort(M_D_SRC_NODE short Node ,unsigned short index, unsigned short value);
void RDWrEvt8Short(M_D_SRC_NODE short Node ,unsigned short index, short value);
void RDWrEvtEdUShort(M_D_SRC_NODE short Node ,unsigned short index, unsigned short value);
void RDWrEvtEdShort(M_D_SRC_NODE short Node ,unsigned short index, short value);

//* aufgerufen bei Veraenderung von EDAT, ETIM, EBIN, ENUM falls vom Umfang long bzw. unsigned long 
void RDWrEvt1ULong(M_D_SRC_NODE short Node, unsigned short index, unsigned long value);
void RDWrEvt1Long(M_D_SRC_NODE short Node, unsigned short index, long value);
void RDWrEvt2ULong(M_D_SRC_NODE short Node, unsigned short index, unsigned long value);
void RDWrEvt2Long(M_D_SRC_NODE short Node, unsigned short index, long value);
void RDWrEvt3ULong(M_D_SRC_NODE short Node, unsigned short index, unsigned long value);
void RDWrEvt3Long(M_D_SRC_NODE short Node, unsigned short index, long value);
void RDWrEvt4ULong(M_D_SRC_NODE short Node, unsigned short index, unsigned long value);
void RDWrEvt4Long(M_D_SRC_NODE short Node, unsigned short index, long value);
void RDWrEvt5ULong(M_D_SRC_NODE short Node, unsigned short index, unsigned long value);
void RDWrEvt5Long(M_D_SRC_NODE short Node, unsigned short index, long value);
void RDWrEvt6ULong(M_D_SRC_NODE short Node, unsigned short index, unsigned long value);
void RDWrEvt6Long(M_D_SRC_NODE short Node, unsigned short index, long value);
void RDWrEvt7ULong(M_D_SRC_NODE short Node, unsigned short index, unsigned long value);
void RDWrEvt7Long(M_D_SRC_NODE short Node, unsigned short index, long value);
void RDWrEvt8ULong(M_D_SRC_NODE short Node, unsigned short index, unsigned long value);
void RDWrEvt8Long(M_D_SRC_NODE short Node, unsigned short index, long value);
void RDWrEvtEdULong(M_D_SRC_NODE short Node, unsigned short index, unsigned long value);
void RDWrEvtEdLong(M_D_SRC_NODE short Node, unsigned short index, long value);

//*  aufgerufen bei Veraenderung von ESTR (mit Laengenuebergabe)
void RDWrEvt1String(M_D_SRC_NODE short Node, unsigned short index, RD_char RD_MRAM *string, RD_size stringsize);
void RDWrEvt2String(M_D_SRC_NODE short Node, unsigned short index, RD_char RD_MRAM *string, RD_size stringsize);
void RDWrEvt3String(M_D_SRC_NODE short Node, unsigned short index, RD_char RD_MRAM *string, RD_size stringsize);
void RDWrEvt4String(M_D_SRC_NODE short Node, unsigned short index, RD_char RD_MRAM *string, RD_size stringsize);
void RDWrEvt5String(M_D_SRC_NODE short Node, unsigned short index, RD_char RD_MRAM *string, RD_size stringsize);
void RDWrEvt6String(M_D_SRC_NODE short Node, unsigned short index, RD_char RD_MRAM *string, RD_size stringsize);
void RDWrEvt7String(M_D_SRC_NODE short Node, unsigned short index, RD_char RD_MRAM *string, RD_size stringsize);
void RDWrEvt8String(M_D_SRC_NODE short Node, unsigned short index, RD_char RD_MRAM *string, RD_size stringsize);
void RDWrEvtEdString(M_D_SRC_NODE short Node, unsigned short index, RD_char RD_MRAM *string, RD_size stringsize);
#if RD_USEFLOAT != 0
    void RDWrEvt1Float(M_D_SRC_NODE short Node, unsigned short index, float value);
    void RDWrEvt2Float(M_D_SRC_NODE short Node, unsigned short index, float value);
    void RDWrEvt3Float(M_D_SRC_NODE short Node, unsigned short index, float value);
    void RDWrEvt4Float(M_D_SRC_NODE short Node, unsigned short index, float value);
    void RDWrEvt5Float(M_D_SRC_NODE short Node, unsigned short index, float value);
    void RDWrEvt6Float(M_D_SRC_NODE short Node, unsigned short index, float value);
    void RDWrEvt7Float(M_D_SRC_NODE short Node, unsigned short index, float value);
    void RDWrEvt8Float(M_D_SRC_NODE short Node, unsigned short index, float value);
	void RDWrEvtEdFloat(M_D_SRC_NODE short Node, unsigned short index, float value);
	
	void RDWrEvt1Double(M_D_SRC_NODE short Node, unsigned short index, double value);
	void RDWrEvt2Double(M_D_SRC_NODE short Node, unsigned short index, double value);
	void RDWrEvt3Double(M_D_SRC_NODE short Node, unsigned short index, double value);
	void RDWrEvt4Double(M_D_SRC_NODE short Node, unsigned short index, double value);
	void RDWrEvt5Double(M_D_SRC_NODE short Node, unsigned short index, double value);
	void RDWrEvt6Double(M_D_SRC_NODE short Node, unsigned short index, double value);
	void RDWrEvt7Double(M_D_SRC_NODE short Node, unsigned short index, double value);
	void RDWrEvt8Double(M_D_SRC_NODE short Node, unsigned short index, double value);
	void RDWrEvtEdDouble(M_D_SRC_NODE short Node, unsigned short index, double value);
#endif

	
void	RDwrCANOPEN(short ControllerID, unsigned short idxSDO, short subidxSDO, void* data, short len);
void 	RDwrCANOPENstr(short ControllerID, unsigned short idxSDO, short subidxSDO, RD_char* data, short len);
void* 	RDrdCANOPEN(short ControllerID, unsigned short idxSDO, short subidxSDO, void* data, short len);
RD_char* RDrdCANOPENstr(short ControllerID, unsigned short idxSDO, short subidxSDO, RD_char* data, short len);



#endif // __CTR_BAS_H__
