//
// $Id: ctr_cons.h 9008 2016-05-11 06:41:38Z hstrauss $
//
// Copyright (c) IMACS GmbH Germany. All rights reserved.
//

#ifndef _CTR_CONS_H_
#define _CTR_CONS_H_




/*************************************************************************
	special character and keyboard definitions
*************************************************************************/


#define	STX			2
#define	ETX			3
#define	ENQ			5
#define	BS			8
#define	TAB			9
#define	LF			10
#define	FF			12
#define	CR			13
#define	ENTER		13
#define	DLE			16
//#define	NAK			21		has been removed because it is defined in PIC32 compiler libraries
#define	ESC			27
#define	SUB			26
#define	SPACE		32
#define	BACKSLASH	92
#define	PGUP		2048
#define	PGDN		2049
#define	HOME		2050
#define	END			2051
#define	UP			2052
#define	DOWN		2053
#define	RIGHT		2054
#define	LEFT		2055
#define	DEL			2056
#define	INS			2057

#define	SHIFT_TAB	2058

#define	KEYABORT	2059
#define	KEYOTHER	2060



#define	F1			2061
#define	F2			2062
#define	F3			2063
#define	F4			2064
#define	F5			2065
#define	F6			2066
#define	F7			2067
#define	F8			2068
#define	F9			2069
#define	F10			2070
#define	F11			2071
#define	F12			2072



#define	ALT_A		2073
#define	ALT_B		2074
#define	ALT_C		2075
#define	ALT_D		2076
#define	ALT_E		2077
#define	ALT_F		2078
#define	ALT_G		2079
#define	ALT_H		2080
#define	ALT_I		2081
#define	ALT_J		2082
#define	ALT_K		2083
#define	ALT_L		2084
#define	ALT_M		2085
#define	ALT_N		2086
#define	ALT_O		2087
#define	ALT_P		2088
#define	ALT_Q		2089
#define	ALT_R		2090
#define	ALT_S		2091
#define	ALT_T		2092
#define	ALT_U		2093
#define	ALT_V		2094
#define	ALT_W		2095
#define	ALT_X		2096
#define	ALT_Y		2097
#define	ALT_Z		2098

#define	SHIFT_F1		2099
#define	SHIFT_F2		2100
#define	SHIFT_F3		2101
#define	SHIFT_F4		2102
#define	SHIFT_F5		2103
#define	SHIFT_F6		2104
#define	SHIFT_F7		2105
#define	SHIFT_F8		2106
#define	SHIFT_F9		2107
#define	SHIFT_F10		2108

#define	CTRL_LEFT		2109
#define	CTRL_RIGHT		2110

#define	P_NULL			2111
#define	P_UP_LE			2112
#define	P_UP			2113
#define	P_UP_RI			2114
#define	P_LE			2115
#define	P_RI			2116
#define	P_DN_LE			2117
#define	P_DN			2118
#define	P_DN_RI			2119
#define	P_MIDDLE		2120

#define	CTRL_P_NULL		2121
#define	CTRL_P_UP_LE	2122
#define	CTRL_P_UP		2123
#define	CTRL_P_UP_RI	2124
#define	CTRL_P_LE		2125
#define	CTRL_P_RI		2126
#define	CTRL_P_DN_LE	2127
#define	CTRL_P_DN		2128
#define	CTRL_P_DN_RI	2129
#define	CTRL_P_MIDDLE	2130


#define	ALTC_A			2131
#define	ALTC_B			2132
#define	ALTC_C			2133
#define	ALTC_D			2134
#define	ALTC_E			2135
#define	ALTC_F			2136
#define	ALTC_G			2137
#define	ALTC_H			2138
#define	ALTC_I			2139
#define	ALTC_J			2140
#define	ALTC_K			2141
#define	ALTC_L			2142
#define	ALTC_M			2143
#define	ALTC_N			2144
#define	ALTC_O			2145
#define	ALTC_P			2146
#define	ALTC_Q			2147
#define	ALTC_R			2148
#define	ALTC_S			2149
#define	ALTC_T			2150
#define	ALTC_U			2151
#define	ALTC_V			2152
#define	ALTC_W			2153
#define	ALTC_X			2154
#define	ALTC_Y			2155
#define	ALTC_Z			2156

#define	CTRL_UP			2157
#define	CTRL_DOWN		2158

#define	SHIFT_UP		2159
#define	SHIFT_DOWN		2160
#define	SHIFT_LEFT		2161
#define	SHIFT_RIGHT		2162

#define	ALT				2163			// only for touch
#define	SHIFT			2164			// only for touch
#define	SHIFTLOCK		2165			// only for touch


#define	CTRL_A			2166
#define	CTRL_B			2167
#define	CTRL_C			2168
#define	CTRL_D			2169
#define	CTRL_E			2170
#define	CTRL_F			2171
#define	CTRL_G			2172
#define	CTRL_H			2173
#define	CTRL_I			2174
#define	CTRL_J			2175
#define	CTRL_K			2176
#define	CTRL_L			2177
#define	CTRL_M			2178
#define	CTRL_N			2179
#define	CTRL_O			2180
#define	CTRL_P			2181
#define	CTRL_Q			2182
#define	CTRL_R			2183
#define	CTRL_S			2184
#define	CTRL_T			2185
#define	CTRL_U			2186
#define	CTRL_V			2187
#define	CTRL_W			2188
#define	CTRL_X			2189
#define	CTRL_Y			2190
#define	CTRL_Z			2191

#define	CTRL_F1			2192
#define	CTRL_F2			2193
#define	CTRL_F3			2194
#define	CTRL_F4			2195
#define	CTRL_F5			2196
#define	CTRL_F6			2197
#define	CTRL_F7			2198
#define	CTRL_F8			2199
#define	CTRL_F9			2200
#define	CTRL_F10		2201
#define	CTRL_F11		2202
#define	CTRL_F12		2203


// wheel definitions
#define	WHEEL_CW		2204		// single step increment
#define	WHEEL_CCW		2205		// single step decrement
#define	WHEEL_FCW		2206		// fast increment
#define	WHEEL_FCCW		2207		// fast decrement
#define	WHEEL_PRESS		2208		// press the wheel

// additional keys
#define	NOKEY			-1

#define	AKEY1			2209
#define	AKEY2			2210
#define	AKEY3			2211
#define	AKEY4			2212
#define	AKEY5			2213

// shift an lock status
#define	SH_LEFT			0x01
#define	SH_RIGHT		0x02
#define	SH_CTRL			0x04
#define	SH_ALT			0x08
#define	SH_SCROLL		0x10
#define	SH_NUM			0x20
#define	SH_CAPS			0x40
#define	SH_INS			0x80

// mouse definitions (click-states)
#define	P_LEFT			2214
#define	P_RIGHT 		2215
#define	P_MID			2216
#define	H_LEFT			2217
#define	H_RIGHT 		2218
#define	H_MID			2219
#define	R_LEFT			2220
#define	R_RIGHT 		2221
#define	R_MID			2222
#define	DC_LEFT			2223
#define	DC_RIGHT 		2224
#define	DC_MID			2225





/*************************************************************************
	color definitions
*************************************************************************/
#define	BLACK		(unsigned char)0
#define	BLUE		(unsigned char)1
#define	GREEN		(unsigned char)2
#define	CYAN		(unsigned char)3
#define	RED	 		(unsigned char)4
#define	MAGENTA		(unsigned char)5
#define	BROWN		(unsigned char)6
#define	LGRAY		(unsigned char)7
#define	DGRAY		(unsigned char)8
#define	LBLUE		(unsigned char)9
#define	LGREEN		(unsigned char)10
#define	LCYAN		(unsigned char)11
#define	LRED		(unsigned char)12
#define	LMAGENTA	(unsigned char)13
#define	YELLOW		(unsigned char)14
#define	WHITE		(unsigned char)15


#define RDCOLPIC	0xfc		// Hintergrundbild restaurieren
#define RDCOL		0xfd		// globale Vordergrundfarbe
#define RDCOLBK		0xfe		// globale Hintergrundfarbe
#define RDCOLNON	0xff		// NON




/*************************************************************************
	font definitions
*************************************************************************/


//*** fixe radCASE fonts			// identifier in radCASE design
#define FIXFONT6X4			0x0406	// 6x4
#define FIXFONT8X6			0x0608	// 8x6
#define FIXFONT10X8			0x080a	// 10x8
#define FIXFONT12X8			0x080c	// 12x8
#define FIXFONT16X8			0x0810	// 16x8
#define FIXFONT16X12		0x0c10	// 16x12
#define FIXFONT16X16		0x1010	// 16x16
#define FIXFONT20X8			0x0814	// 20x8
#define FIXFONT24X16		0x1018	// 24x16
#define FIXFONT32X20		0x1420	// 32x20

//*** prop. radCASE fonts			// identifier in radCASE design
#define PROPFONT7X8			0x3F07	// 7p
#define PROPFONT8X12		0x3F08	// 8p
#define PROPFONT10X16		0x3F0A	// 10p
#define PROPFONT12X19		0x3F0C	// 12p
#define PROPFONT14X22		0x3F0E	// 14p
#define PROPFONT16X24		0x3F10	// 16p
#define PROPFONT24X36		0x3F18	// 24p
#define PROPFONT36X48		0x3F24	// 36p
#define PROPFONT48X72		0x3F30	// 48p
#define PROPFONT72X107		0x3F48	// 72p

//*** fonts for systems with font engine (Windows, Linux, QT)
#define RD_FNTARIAL			0x4000
#define RD_FNTCOURIER		0x5000
#define RD_FNTTERMINAL		0x6000
#define	RD_FNTFIXEDSYS		0x7000
#define	RD_FNTTAHOMA		0x8000
#define	RD_FNTSANSSERIF		0x9000
#define	RD_CUSTOMA			0xA000	// ID of custom fonts
#define	RD_CUSTOMB			0xB000
#define	RD_CUSTOMC			0xC000
#define	RD_CUSTOMD			0xD000
#define	RD_CUSTOME			0xE000
#define	RD_CUSTOMF			0xF000
	// => OR connect with
#define	RD_FNTBOLD			0x0100
#define	RD_FNTITALIC		0x0200
#define	RD_FNTUNDERL		0x0400

// cursor modes
#define	CUR_FULL	1
#define	CUR_HALF	2
#define	CUR_ARROW	3

// special keys values (normally by pressing multiple keys at once)
#define	KEY_SETUP		0x7ff3		// c_key_test() Scanwert fuer SETUP
#define	KEY_QUICK		0x7ff4		// c_key_test() Scanwert fuer Hardwareschnelltest
#define	KEY_SELFTEST	0x7ff6		// c_key_test() Scanwert fuer Selbsttest



// parameter for setFont()
#ifdef	RD_DYNAMIC_FONT
	#define UNI_DYNAMIC		,1
	#define NO_UNI_DYNAMIC	,0
#else
	#define UNI_DYNAMIC	
	#define NO_UNI_DYNAMIC			
#endif
#ifdef MAXLINES96		// X x 768 Pixel bei 6x8 
	#define	MAX_LINES	96
	#define	POS_MES_Y	-200		// Y-Startpos. der Edit- und Messageboxen
	#define	SIZE_MES_Y	-120		// Y-Groesse der Messageboxen
	#define	SIZE_EDIT_Y	-180		// Y-Groesse der Editboxen
#endif
#ifdef MAXLINES64		// X x 768 Pixel bei 8x12 
	#define	MAX_LINES	64
	#define	POS_MES_Y	-200		// Y-Startpos. der Edit- und Messageboxen
	#define	SIZE_MES_Y	-120		// Y-Groesse der Messageboxen
	#define	SIZE_EDIT_Y	-180		// Y-Groesse der Editboxen
#endif
#ifdef MAXLINES75		// X x 600 Pixel bei 6x8 
	#define	MAX_LINES	75
	#define	POS_MES_Y	-200		// Y-Startpos. der Edit- und Messageboxen
	#define	SIZE_MES_Y	-120		// Y-Groesse der Messageboxen
	#define	SIZE_EDIT_Y	-180		// Y-Groesse der Editboxen
#endif
#ifdef MAXLINES50		// X x 600 Pixel bei 8x12 
	#define	MAX_LINES	50
	#define	POS_MES_Y	-200		// Y-Startpos. der Edit- und Messageboxen
	#define	SIZE_MES_Y	-120		// Y-Groesse der Messageboxen
	#define	SIZE_EDIT_Y	-180		// Y-Groesse der Editboxen
#endif
#ifdef MAXLINES60		// X x 480 Pixel (6x8)
	#define	MAX_LINES	60
	#define	POS_MES_Y	-160
	#define	SIZE_MES_Y	-120	
	#define	SIZE_EDIT_Y	-180	
#endif
#ifdef MAXLINES40		// X x 480 Pixel (8x12)
	#define	MAX_LINES	40
	#define	POS_MES_Y	-160
	#define	SIZE_MES_Y	-120	
	#define	SIZE_EDIT_Y	-180	
#endif
#ifdef MAXLINES30		// X x 240 Pixel (bei 6x8) 
	#define	MAX_LINES	30
	#define	POS_MES_Y	-40
	#define	SIZE_MES_Y	-120	
	#define	SIZE_EDIT_Y	-180	
#endif
#ifdef MAXLINES20		// X x 240 Pixel (bei 8x12)
	#define	MAX_LINES	20
	#define	POS_MES_Y	-40
	#define	SIZE_MES_Y	-120	
	#define	SIZE_EDIT_Y	-180	
#endif
#ifdef MAXLINES16		// X x 128 Pixel
	#define	MAX_LINES	16
	#define	POS_MES_Y	-32
	#define	SIZE_MES_Y	-128	
	#define	SIZE_EDIT_Y	-128	
#endif
#ifdef MAXLINES8		// X x 64 Pixel
	#define	MAX_LINES	8
	#define	POS_MES_Y	0
	#define	SIZE_MES_Y	-64	
	#define	SIZE_EDIT_Y	-64	
#endif
#ifdef MAXLINES4		// X x 32 Pixel
	#define	MAX_LINES	4
	#define	POS_MES_Y	0
	#define	SIZE_MES_Y	-32	
	#define	SIZE_EDIT_Y	-32	
#endif
#ifdef MAXLINES2		// X x 16 Pixel (zweizeilig)
	#define	MAX_LINES	2
	#define	POS_MES_Y	0
	#define	SIZE_MES_Y	-16	
	#define	SIZE_EDIT_Y	-16	
#endif
#ifdef MAXLINES1		// X x 8 Pixel	(einzeilig)
	#define	MAX_LINES	1
	#define	POS_MES_Y	0
	#define	SIZE_MES_Y	-8	
	#define	SIZE_EDIT_Y	-8	
#endif


#ifdef MAXCOLUMNS6		
	#define	MAX_COLUMNS	6
	#define	POS_MES_X	0		// Y-Startpos. der Edit- und Messageboxen
	#define	SIZE_MES_X	-36		// Y-Groesse der Edit- und Messageboxen
#endif
#ifdef MAXCOLUMNS16		// 96 x Y Pixel (16 Zeichen)
	#define	MAX_COLUMNS	16
	#define	POS_MES_X	0
	#define	SIZE_MES_X	96
	#define	POS_ENTER_X	72
#endif
#ifdef MAXCOLUMNS20		// 120/122 x Y Pixel (20 Zeichen)
	#define	MAX_COLUMNS	20
	#define	POS_MES_X	0
	#define	SIZE_MES_X	120
	#define	POS_ENTER_X	82	
#endif
#ifdef MAXCOLUMNS21		// 128 x Y Pixel
	#define	MAX_COLUMNS	21
	#define	POS_MES_X	0
	#define	SIZE_MES_X	128
	#define	POS_F2_X	44	
	#define	POS_ENTER_X	88	
#endif
#ifdef MAXCOLUMNS26		// 160 x Y Pixel
	#define	MAX_COLUMNS	26
	#define	POS_MES_X	0
	#define	SIZE_MES_X	160
	#define	POS_F2_X	60	
	#define	POS_ENTER_X	120	
#endif
#ifdef MAXCOLUMNS32		// 192 x Y Pixel
	#define	MAX_COLUMNS	32
	#define	POS_MES_X	0
	#define	SIZE_MES_X	192
	#define	POS_F2_X	76	
	#define	POS_ENTER_X	152	
#endif
#ifdef MAXCOLUMNS40
	#if MAX_LINES > 8	// 320 x Y Pixel (8x12); 240 x 128 Pixel (6x8)
	 	#define	MAX_COLUMNS	40
		#define	POS_MES_X	40
		#define	SIZE_MES_X	200
		#define	POS_F2_X	60	
		#define	POS_ENTER_X	120	
	#else				// 240 x Y Pixel (6x8); 240 x 64 Pixel (6x8)
	 	#define	MAX_COLUMNS	40
		#define	POS_MES_X	0
		#define	SIZE_MES_X	200
		#define	POS_F2_X	44	
		#define	POS_ENTER_X	200	
	#endif
#endif
#ifdef MAXCOLUMNS42		// 256 x Y Pixel (6x8)
 	#define	MAX_COLUMNS	42
	#define	POS_MES_X	40
	#define	SIZE_MES_X	200
	#define	POS_F2_X	60	
	#define	POS_ENTER_X	120	
#endif
#ifdef MAXCOLUMNS53		// 320 x Y Pixel (6x8)
	#define	MAX_COLUMNS	53
	#define	POS_MES_X	40
	#define	SIZE_MES_X	250
	#define	POS_F2_X	64	
	#define	POS_ENTER_X	200	
#endif
#ifdef MAXCOLUMNS80		// 640 x Y Pixel (8x12) 
	#define	MAX_COLUMNS	80
	#define	POS_MES_X	200
	#define	SIZE_MES_X	250
	#define	POS_F2_X	64	
	#define	POS_ENTER_X	200	
#endif
#ifdef MAXCOLUMNS106	// 640 x Y Pixel (6x8)
	#define	MAX_COLUMNS	106
	#define	POS_MES_X	200
	#define	SIZE_MES_X	250
	#define	POS_F2_X	64	
	#define	POS_ENTER_X	200	
#endif
#ifdef MAXCOLUMNS100	// 800 x Y Pixel (bei 8x12)
	#define	MAX_COLUMNS	100
	#define	POS_MES_X	250
	#define	SIZE_MES_X	250
	#define	POS_F2_X	64	
	#define	POS_ENTER_X	200	
#endif
#ifdef MAXCOLUMNS133	// 800 x Y Pixel (bei 6x8)
	#define	MAX_COLUMNS	133
	#define	POS_MES_X	250
	#define	SIZE_MES_X	250
	#define	POS_F2_X	64	
	#define	POS_ENTER_X	200	
#endif
#ifdef MAXCOLUMNS128	// 1024 x Y Pixel (bei 8x12)
	#define	MAX_COLUMNS	128
	#define	POS_MES_X	250
	#define	SIZE_MES_X	250
	#define	POS_F2_X	64	
	#define	POS_ENTER_X	200	
#endif
#ifdef MAXCOLUMNS170	// 1024 x Y Pixel (bei 6x8)
	#define	MAX_COLUMNS	170
	#define	POS_MES_X	250
	#define	SIZE_MES_X	250
	#define	POS_F2_X	64	
	#define	POS_ENTER_X	200	
#endif

// Defines for extended rectangles
#define RD_EXTRECT_BORDERBRIGHTNESS	60
#define RD_EXTRECT_WIDTHBORDER		1
#define RD_EXTRECT_WIDTH3D			9


extern	RD_CONST	unsigned char	RD_pos2char[];

extern	RD_char		_DezPoint;
extern	RD_COLOR	RD_EditCol;			// colour for modifing value
extern	RD_COLOR	RD_EditColBk;		// background colour for modifing value
extern	char		RD_fModified;		// an element was changed (for save-question)
extern	short		_f_insert;			// 0/1 = insert mode off/on
#ifdef RD_NO_COLOR
extern  char		RD_fInvert;			// Invert the actual line (has to be processed in API)
#endif // RD_NO_COLOR


#ifdef SIM
extern	unsigned char	LOCAT *c_scrbk;
#endif

extern	short			_c_actwin;
extern	unsigned short	_sysFont;		// HSB = Breite, LSB = Hoehe, falls bit14 = 1 => Proportionalfont (Zukunft)
extern	unsigned char	_sysFontWidth;	// breite des aktueller Fonts
extern	unsigned char	_sysFontHeight;	// hoehe aktueller Fonts
extern	unsigned char	_curFontWidth;
extern	unsigned char	_curFontHeight;
extern	char			_fDynamic;						// Flag: Dynamic bei der aktuellen Ausgabe verlangt
#if DISP_TXT != 0
extern  short			*_cursorPosX;
extern  short			*_cursorPosY;
#endif // DISP_TXT != 0

extern short			fDebug;
extern short			fFlags;

#if NO_EMB_HMI == 0
#if ((RD_LAYER != 0) || ((RD_NO_DISPLAYCOMM == 0) && (RD_DISPCMD_COMMUNICATION != 0)))
extern short rd_currentLayer;
#endif
#if ((RD_NO_DISPLAYCOMM == 0) && (RD_DISPCMD_COMMUNICATION != 0))
extern short rd_currentCursorMode;
#endif
#endif

//*********************************
// Functions - Display
//*********************************
void	c_dis_clr(M_D_SCR_S);

void	c_dis_set_pixel(M_D_SCR short, short 											M_D_COL);
void	c_dis_char(M_D_SCR short sx, short sy, RD_char c								M_D_COL M_D_COLBK);
void	c_dis_char16(M_D_SCR short sx, short sy, unsigned short c						M_D_COL M_D_COLBK);
void	c_dis_str(M_D_SCR short sx, short sy, RD_char RD_MRAM *str, short len		M_D_COL M_D_COLBK);
void	c_dis_str16(M_D_SCR short sx, short sy, unsigned short RD_MRAM *str, short len	M_D_COL M_D_COLBK);
void	c_dis_line(M_D_SCR short sx, short sy, short ex, short ey, short pensize	M_D_COL);
void	c_dis_rect(M_D_SCR short sx, short sy, short sizex, short sizey, short pensize	M_D_COL, short fillmodus);
void	c_dis_circ(M_D_SCR short sx, short sy, short radx,  short rady,  short pensize	M_D_COL);
void	c_dis_arc(M_D_SCR  short sx, short sy, short radx,  short rady,  short startang, short endang, short pensize M_D_COL);
void	c_dis_bitmap(M_D_SCR   short, short, unsigned char RD_MROM *);
void	c_dis_bitmap_ext(M_D_SCR   short, short, long);
void	c_dis_getBitmapSize(unsigned char RD_MBIN *, short RD_MRAM *, short RD_MRAM *);
void	c_dis_getBitmapSize_ext(long index, short RD_MRAM *, short RD_MRAM *);
void	c_dis_clrrect(M_D_SCR short sx, short sy, short sizex, short sizey	 			M_D_COL);
void	c_cur_set(M_D_SCR short, short M_D_COL M_D_COLBK);
void	c_cur_move(M_D_SCR short, short	M_D_COL M_D_COLBK);
void	c_cur_mode(M_D_SCR short);
void	c_cur_clear(M_D_SCR_S);
void	c_dis_layer(M_D_SCR short layer);
#if RD_EXTGRA != 0
void	c_dis_area_init(M_D_SCR unsigned char anz);
void	c_dis_save_area(M_D_SCR short x, short y, short width, short height, unsigned char areaID);
void	c_dis_restore_area(M_D_SCR unsigned char areaID);
void	c_dis_bitmap_rot(M_D_SCR short x, short y, short rotX, short rotY, unsigned char RD_MROM *bmpptr, long rotkangle);
void	c_dis_bitmap_rot_ext(M_D_SCR short x, short y, short rotX, short rotY, long offset, long rotkangle);
#endif // RD_EXTGRA != 0

void	c_dis_clr1(M_D_SCR_S);
void	c_dis_layer1(M_D_SCR short setLayer);
void	c_dis_line1(M_D_SCR short sx, short sy, short ex, short ey, short pensize M_D_COL);
void	c_dis_rectext1(M_D_SCR short sx, short sy, short sizex, short sizey, char rad M_D_COL, char contrastx, char contrasty, unsigned char mode);
void	c_dis_rect1(M_D_SCR short sx, short sy, short sizex, short sizey, short pensize M_D_COL, short fillmodus);
void	c_dis_circ1(M_D_SCR short sx, short sy, short radx,  short rady, short pensize M_D_COL);
void	c_dis_arc1(M_D_SCR  short sx, short sy, short radx,  short rady, short startang, short endang, short pensize M_D_COL);
void 	c_dis_clrrect1(M_D_SCR short x, short y, short sizex, short sizey M_D_COL);
void	c_dis_bitmap1(M_D_SCR   short, short, long offset);
#if RD_UNICODESETTING != 2
void	c_dis_char1(M_D_SCR short sx, short sy, RD_char c	M_D_COL M_D_COLBK);
void	c_dis_str1(M_D_SCR short sx, short sy, RD_char RD_MRAM *str, short len		M_D_COL M_D_COLBK);
#else
void	c_dis_char161(M_D_SCR short sx, short sy, unsigned short c						M_D_COL M_D_COLBK);
void	c_dis_str161(M_D_SCR short sx, short sy, unsigned short RD_MRAM *str, short len	M_D_COL M_D_COLBK);
#endif

#if ((DISP_GRA != 0) && !defined(RD_NO_GRAPRIM) && (RD_EXTENDEDRECT != 0))
// extended rectangle function pointer
typedef unsigned char (*CUS_EXT_RECT)(M_D_SCR short sx, short sy, short sizex, short sizey,
			char rad M_D_COL, char contrastx, char contrasty, unsigned char mode);
extern CUS_EXT_RECT RDfp_extRect;
#endif // ((DISP_GRA != 0) && !defined(RD_NO_GRAPRIM) && (RD_EXTENDEDRECT != 0))

#if RD_PROPFONT != 0
unsigned long c_dis_getStrDimension(M_D_SCR RD_char RD_MRAM *str);
#endif // RD_PROPFONT != 0

#if RD_EXTGRA != 0
void c_dis_area_init1(M_D_SCR unsigned char count);
void c_dis_save_area1(M_D_SCR short x, short y, short width, short height, unsigned char areaID);
void c_dis_restore_area1(M_D_SCR unsigned char areaID);
void	c_dis_bitmap1_rot(M_D_SCR   short x, short y, short rotX, short rotY, long offset, long rotkangle);
#endif // RD_EXTGRA != 0


void	c_cur_setPos(M_D_SCR short, short M_D_COL M_D_COLBK);
void	c_cur_movePos(M_D_SCR short, short M_D_COL M_D_COLBK);
void	c_cur_clear1(M_D_SCR_S);
void	c_cur_mode1(M_D_SCR short);

void	c_dis_moveWinUp(void);
void	c_dis_moveWinDown(void);
void	c_dis_moveWinToggle(void);
void	c_dis_moveWinReset(void);


unsigned short getFontHeightWidth(unsigned short font, unsigned char *height, unsigned char *width);
void	setFont(unsigned short size
#ifdef	RD_DYNAMIC_FONT
		, short forceUnicode
#endif
);




//*********************************
// Functions - Touchscreen
//*********************************
#if TOUCH_ON != 0
	
	
	//*** API-Funktionen
	short	c_touch_pressed(void);
	short	c_touch_stat(M_D_SCR short RD_MRAM *x, short RD_MRAM *y);
	short	c_touch_in(M_D_SCR   short RD_MRAM *x, short RD_MRAM *y);
	short	c_touch_test(M_D_SCR short RD_MRAM *x, short RD_MRAM *y);
	short	c_touch_scan(M_D_SCR short RD_MRAM *x, short RD_MRAM *y);
	void	c_touch_del(M_D_SCR_S);
	void	c_touch_put(M_D_SCR short x, short y, short pressed);

	//*** wie oben, jedoch rel. zum aktuellen Ursprung
	short	c_touch_stat1(M_D_SCR short RD_MRAM *x, short RD_MRAM *y);
	short	c_touch_in1(M_D_SCR   short RD_MRAM *x, short RD_MRAM *y);
	short	c_touch_test1(M_D_SCR short RD_MRAM *x, short RD_MRAM *y);
	
	typedef short (*C_TOUCH)(M_D_SCR short x, short y);
	extern	C_TOUCH c_touch_pos2key;
	
	short	c_touch_mode(M_D_SCR short mode, short x, short y);
	void  c_touch_getCalibrationData(long *An, long *Bn, long *Cn, long *Dn, long *En, long *Fn, long *Divider);
	void  c_touch_setCalibrationData(long An, long Bn, long Cn, long Dn, long En, long Fn, long Divider);

#endif



//*********************************
// Functions - Keyboard
//*********************************
short	c_inkey(M_D_SCR_S);

short	c_key_in(M_D_SCR_S);
short	c_key_stat(M_D_SCR_S);
short	c_key_test(M_D_SCR_S);
void	c_key_put(M_D_SCR short key);


//*** Keymapping 
// Voraussetzungen:
// - die Systemfunktionen koennen immer mindestens 6 Tasten verwenden: Up, Down, Left, Right, Escape und Enter
// - falls eine dieser Tasten fehlt, wird sie im Systemkeymap vor einer anderen Taste ersetzt
// - zusaetzlich koennen in den Systemfunktionen noch weitere virtuelle Tasten auftauchen
//	 in Radon wird die Anzahl dieser virtuellen Tasten angegeben, sie werden dann von anderen Tasten gemappt

#define	KEYMAP_SYSTEM	0		// Key-Map in den Systemfunktionen
#define	KEYMAP_EDIT		1		// Key-Map in der Editierung
#define	KEYMAP_USER		2		// Key-Map in der Projektabhaengige Oberflaeche

void	c_key_setMap(M_D_SCR short);
short	c_key_getMap(M_D_SCR_S);


//*** virtuelle Tasten fuer Systemfunktionen siehe ctr_def.h
short	key_pressed_stat(M_D_SCR short);
short	key_pressed(short);

short	mapSimKey(M_D_SCR short);

//*********************************
// Functions - Ethernet
//*********************************
#if ETHERNET_ON != 0

/** \brief executes an command for the ethernet interface
 *
 * \param[in] command Command to execute
 * \param[in,out] cmdData Pointer to structure containing data of the command also used to return data
 * \return 0 if command fails else 1
 */
unsigned char execEthCommand(unsigned char command, void * cmdData);

// Commands to execute
#define RD_ETHCMD_GET_SUPPORTED		0
#define RD_ETHCMD_GET_IP			1
#define RD_ETHCMD_SET_IP			2
#define RD_ETHCMD_GET_SUBMASK		3
#define RD_ETHCMD_SET_SUBMASK		4
#define RD_ETHCMD_GET_GATEWAY		5
#define RD_ETHCMD_SET_GATEWAY		6
#define RD_ETHCMD_USER_CMD			128

// Values for bitmask of supported commands
#define RD_CMDSUP_GETIP				1
#define RD_CMDSUP_SETIP				2
#define RD_CMDSUP_DHCP				4
#define RD_CMDSUP_GETSUB			8
#define RD_CMDSUP_SETSUB			16
#define RD_CMDSUP_GETGW				32
#define RD_CMDSUP_SETGW				64

// Strucutre for passing IP address in format byte0.byte1.byte2.byte3
struct RdEthCmdIP {
	unsigned char byte0;
	unsigned char byte1;
	unsigned char byte2;
	unsigned char byte3;
};

// Structure for passing a bitmask of supported commands
// Note: Structure to be able to change data type, when more commands
// will be added
struct RdEthCmd {
	unsigned char bitmask;
};

#endif // ETHERNET_ON != 0

//*********************************
// Functions - others
//*********************************
void	c_beep(short freq);
void	c_doku_oversize(short onOff);
void SetMenuCursorVisible(unsigned char now);

void setInternCtrLanguage(void);

#ifndef ___CTR___
	void output(char *item, short wert);
	void outputc(char *item, char wert);
	void c_beepTime(short freq, short length);
	unsigned char c_getPauseSimulation(void);
#endif
void executeINIT(void);

#endif
