// Font Table Header
typedef struct 
{
	char			fmarker[3];			// fix rCF for Indetification, not evaluated by Software
	char			version;			// Version of Fonthandling procedure, currently always "1" = 0x31, currently not evaluated by Software
	char			name[16];			// Fontname, not evaluated by Software
	unsigned char	size;				// Nominal Size of Font, not evaluated by Software
	unsigned char	boxSizeX;			// Box Width (0 in case of Prop-Font)
	unsigned char	boxSizeY;			// Box Hight 
	unsigned char	resolution;			// Resolution of bit pattern, may be 1,2 or 4
	unsigned char	optimization;		// Optimzation Level (0,1,2), currently only level 0 supported
	unsigned char	orientation;		// Pixel Block Orientation: 0=Horizontal, 1=Vertical
	unsigned char	tableSpacing;		// Multiplication value for Offset values in several sustructures as shift value : 0= *1, 1= *2, 2= *4, 
	unsigned short	numOfBlocks ;		// Number of offsetBlocksTables
//	rC_SFBlockTab	offsetBlocksTables[NumOfBlocks];		// List of Offset Blocks, will always be immediately following the header structure
}rC_SFHeader;

// Font Table Offset descriptor, describing on block of chars
typedef struct 
{
	unsigned short	firstChar;			// first char of char subset for this Block
	unsigned short	lastChar;			// last char of char subset for this Block
	unsigned short	offsetCharTag;		//Offset of List of Char Offsets vs. Base Address of Font Table, must be shifted by tableSpacing to get effective offset, see below for content
} rC_SFBlockTab;

// every Element offsetCharTag of the struct rC_SFBlockTab points to a List of offsetChar :
//	unsigned short	offsetChar[lastChar-firstChar+1];		// Offset vs. Base Address of Font Table of the struct rC_SFChar of the Specific Char, must be shifted by tableSpacing to get effective Offset
// if the offsetChar is NULL, there is no Char Pattern for this specific Char available and the Char will not be printed 

// structure holding pattern for one single char
typedef struct 
{
	unsigned char	sizeX;			// Pattern Width (Pattern Hight is globally defined as boxSizeY)
	unsigned char 	offX;			// Only used for Optimization Level > 0 (future use)
	unsigned char 	offY;			// Only used for Optimization Level > 0 (future use)
	unsigned char	usedX;			// Only used for Optimization Level > 0 (future use)
	unsigned char	usedY;			// Only used for Optimization Level > 0 (future use)
	unsigned char	fontData;		// first byte of Font pattern using 1,2 or 4 bits per pixel, vertically or horzontally arranged. Font data is really an array of unsigned char !
} rC_SFChar;

