#ifndef __CTR_HIM_H__
#define __CTR_HIM_H__

/***************************************************************************
 adress IO-definitions
***************************************************************************/
#define	COM_RECEIVE_TAB		  	0x11
#define	COM_SEND_BLOCK		  	0x12
#define	COM_DIRECT		  	0x13
#define	COM_RECEIVE_KEY		  	0x14
#define	COM_KEY_FREIGABE		0x15
#define	COM_SEND_HIS_TAB		0x16
#define	COM_SEND_HIS_BLOCK		0x17
#define	COM_SECURITY			0x18
#define	COM_RECEIVE_DATA		0x19
#define	COM_TRANSMIT			0x1A
#define	COM_FLASH_DEL			0x1B
#define	COM_FLASH_DEL_DONE		0x1C
#define	COM_FLASH_WRITE			0x1D
#define	COM_SYS_RESET			0x1E
#define	COM_PROG_START			0x1F
#define	COM_LANGUAGE			0x20
#define	COM_TASK_RUN			0x21
#define	COM_BOOT_START			0x22
#define	COM_TRANSPARENT			0x23
#define	COM_F_POWER			0x24
#define	COM_HIST			0x25
#define	COM_CALL			0x26

#define	DIRECT_ON			0xFE
#define	DIRECT_OFF	 		0xFF





/*********************************************************************
 macro definitions
*********************************************************************/
#define AO_ADR(off)     (off<<1)+MEM_AO
#define AI_ADR(off)     (off<<1)+MEM_AI
#ifdef ___CTR___
	#define	TIM(timer,mode)		MEM_TIM + ((timer) * 4),(mode)
#else
	#define	TIM(timer,mode)		(timer),(mode)
#endif

#ifndef BIT
	#define	BIT(bit)		(unsigned short)((unsigned short)1 << bit)
#endif



#define max(a,b)	(((a) > (b)) ? (a) : (b))
#define min(a,b)	(((a) < (b)) ? (a) : (b))


#ifdef ___CTR___
#ifdef __cplusplus
extern	"C"
{
#endif	
#endif



//**********************************************************************
//
//**********************************************************************

#ifdef ___CTR___
	#ifdef IMACS_01
		char			*strchr(char *, int);
		unsigned short	strlen(char *);
		char			*strcpy(char *, char *);
		char			*strncpy(char *, char *, int);
		short	   		strcmp(char *, char *);
		short			strncmp(char *, char *, int);
		char			*strcat(char *, char *);
		char			*strncat(char *, char *, int);
		char			*strtok(char *s, char *t);

		void			*memcpy(void *, void *, unsigned short);
		void			*memmove(void *, void *, unsigned short);
		short			memcmp(void *, void *, unsigned short);
	#endif


	RD_char	RD_MRAM *strfill(RD_char RD_MRAM *, RD_char, RD_size);
	RD_char	RD_MRAM *strexp(RD_char	RD_MRAM *, RD_size);
	RD_char	RD_MRAM *strcut(RD_char	RD_MRAM *);
	
	void	RD_MBIN *_fmemcpy(void RD_MBIN *, void RD_MBIN *, unsigned short);
	void	RD_MBIN *_fmemmove(void RD_MBIN *, void RD_MBIN *, unsigned short);
#endif	


#ifdef ___CTR___
#ifdef __cplusplus
}
#endif	
#endif

#endif // __CTR_HIM_H__
