//
// $Id: ctr_io.h 8894 2016-03-14 11:57:13Z wdaur $
//
// Copyright (c) IMACS GmbH Germany. All rights reserved.
//

#ifndef __CTR_IO_H__
#define __CTR_IO_H__

#ifndef __CTR_BAS_H__
#define	CElement	unsigned char		
#endif

#if defined(___CTR___) && (RD_GAMMA != 0)
#include <gaapi/api.h>
#endif // defined(___CTR___) && (RD_GAMMA != 0)

struct S_Modul; // Forward declaration

#define EXITALL	1000		// control index used in kali menues

/* legacy defines, unused in present RC_lib
#define	O_AN		0
#define	O_PORT		1
#define	O_TIM		2
#define	O_CNT		3
#define	O_VAR		4
#define	O_BITGRP	5

#define	CNT_BI      0
#define	CNT_UNI     1   

#define	BUS_IO		0

// kind if keys / switch
#define MB_KEY_C	0
#define MB_KEY_O	1
#define MB_SWITCH	2

// binary object types
#define	OB_IO		0
*/
 

#ifndef IO_const
	#define	IO_const
	// IO_const could be set to RD_CONST to make all E_DI and E_DO structures constant. 
	// In this case, alse the define RD_DISABLE_DX_LOGIC must also be set
#endif

// defines for hardwareID in IO describing structures 
#define  HID_INTERN			0x0000			// internal on the main board (= Default)
#define  HID_EXP_MOD1		0x0001			// 1st IO board (general)
#define  HID_EXP_MOD2		0x0002			// 2nd IO board (general)
#define  HID_EXP_MOD3		0x0003			// 3rd IO board (general)
#define  HID_EXP_MOD4		0x0004			// 4th IO board (general)
// further IO boards to be defined individually
#define  HID_emBRICK0		0x0100			//emBRICK Node 0
#define  HID_emBRICKLAST	0x01FF			//emBRICK last theoretically possible node
#define	 HID_UNUSED			0xFF00			// Device ist designed, but has no hardware equivalent

// test macros?
#define		IS_AI	(iotype == IOTYPE_AI)
#define		IS_AO	(iotype == IOTYPE_AO)
#define		IS_CNT	(iotype == IOTYPE_CNT)

 
// macros for length determination
#define	OBJ_AT(tab)	tab,sizeof(tab) / sizeof(OBJ_A *)
#define TCH_DI(tab)	tab,sizeof(tab) / sizeof(CH_DI *)
#define TCH_DO(tab)	tab,sizeof(tab) / sizeof(CH_DO *)
 
#define	T_VISB(tab)	tab,sizeof(tab) / sizeof(VIS_B)
#define	T_VISN(tab)	tab,sizeof(tab) / sizeof(VIS_N)
#define T_MANB(tab)	tab,sizeof(tab) / sizeof(MAN_B)
#define T_MANN(tab)	tab,sizeof(tab) / sizeof(MAN_N)
#define T_OBJB(tab)	tab,sizeof(tab) / sizeof(OBJ_B *)
#define T_OBJN(tab)	tab,sizeof(tab) / sizeof(OBJ_N *)
#define T_IND(tab)	tab,sizeof(tab) / sizeof(IND *)

struct s_kaliio;
typedef unsigned short (*t_caliConvertFP)(struct s_kaliio RD_MIO *io, void *unconverted, void* converted);

typedef	struct {
	unsigned short	port;			// Hardware-port
	unsigned short	h_mask;			// Hardware-Bitmaske
	unsigned char	h_inv;			// Hardware-Inverse-flag
	unsigned short	adr;			// MEMIO-Adresse
	unsigned char	mask;			// MEMIO-Bitmaske
	short			status;			// -1: Hardware, 0: unset, 1: set
	RD_CONST CEBin	RD_MROM *elem;	// Zeiger auf zug. Element
	unsigned short	hardwareID;
	unsigned char	act;			// actual logical state
	#if NO_EMB_HMI == 0
		unsigned char	old;		// last logical state
	#endif
	} E_DI;


typedef	struct {
	unsigned short	port;			// Hardware-Port
	unsigned short	h_adr;			// Hardware-Adressen-Kopie
	unsigned short	h_mask;			// Hardware-Bitmaske
	unsigned char	h_inv;			// Hardware-Inverse-flag
	unsigned short	adr;			// MEMIO-Adresse
	unsigned char	mask;			// MEMIO-Bitmaske
	RD_CONST CEBin	RD_MROM *elem;	// Zeiger auf zug. Element
	unsigned short	hardwareID;
	unsigned char	act;			// actual logical state
	#if NO_EMB_HMI == 0
		unsigned char	old;		// last logical state
	#endif
	} E_DO;

typedef	struct {
	unsigned short	index;		// Basisadresse des A/D-Wandlers
	unsigned short adr;			// MEMIO-Adresse
	short	pOffStd;	// Standartwerte fuer die Kalibrierung
	short	pFullStd;	// Standartwerte fuer die Kalibrierung
	short	lOffStd;	// Standartwerte fuer die Kalibrierung
	short	lFullStd;	// Standartwerte fuer die Kalibrierung
	RD_CONST CENum	RD_MROM *elem;		// Zeiger auf zug. Element
    t_caliConvertFP fp_caliConvert; // Function pointer to conversion function
	Kali  	RD_MRAM *kali;		// Pointer to calibration
	unsigned char	mode; 		// Wandelmodus
	unsigned char	filter;		// Filter-"Tiefe"
	unsigned short	hardwareID;

	short	act;
	long	mittelwert;
	short	physact;
	unsigned char	access;		// enablen und disablen von kali, diag und prot
#if NO_FORCEMODE != 0
	unsigned char	dummy;		// noch frei, nur wegen alignment vorhanden  
#else
	unsigned char	force;		// Force-Flag  
#endif
	} E_AI;



typedef	struct {
	unsigned short	index;		// Basisadresse des D/A-Wandlers
	unsigned short adr;				// MEMIO-Adresse
	short	pOffStd;	// Standartwerte fuer die Kalibrierung
	short	pFullStd;	// Standartwerte fuer die Kalibrierung
	short	lOffStd;	// Standartwerte fuer die Kalibrierung
	short	lFullStd;	// Standartwerte fuer die Kalibrierung
	RD_CONST CENum	RD_MROM *elem;		// Zeiger auf zug. Element
    t_caliConvertFP fp_caliConvert; // Function pointer to conversion function
	Kali  	RD_MRAM *kali;		// Pointer to calibration
	unsigned short	hardwareID;

	short	act;
	short	physact;
	unsigned char	access;		// enablen und disablen von kali, diag und prot
	unsigned char	force;		// Force-Flag  
	short	stat;
	} E_AO;



typedef	struct {		//*** Zaehler
	unsigned short	index;		// Basisadresse des Counters
	unsigned short adr;			// MEMIO-Adresse
	short	pOffStd;	// Standartwerte fuer die Kalibrierung
	short	pFullStd;	// Standartwerte fuer die Kalibrierung
	short	lOffStd;	// Standartwerte fuer die Kalibrierung
	short	lFullStd;	// Standartwerte fuer die Kalibrierung
	RD_CONST CENum	RD_MROM *elem;		// Zeiger auf zug. Element
    t_caliConvertFP fp_caliConvert; // Function pointer to conversion function
	Kali  RD_MRAM	*kali;		// Pointer to calibration
	unsigned short	hardwareID;
	
	long	act;
	long	old;
	long	physact;
#if NO_FORCEMODE == 0
	long	stat;
#endif
	unsigned char	access;		// enablen und disablen von kali, diag und prot
	unsigned char	remanent;	// remanent-flag  
#if NO_FORCEMODE == 0
	unsigned char	force;		// Force-Flag  
	unsigned char	dummy;		// noch frei, nur wegen alignment vorhanden  
#endif
	} E_CNT;
	
// Nur zum Casten, um gleiche Struktur in E_AI, E_AO und E_CNT zu haben
typedef	struct s_kaliio {
	unsigned short	index;		// Basisadresse des A/D-Wandlers
	unsigned short adr;			// MEMIO-Adresse
	short	pOffStd;	// Standartwerte fuer die Kalibrierung
	short	pFullStd;	// Standartwerte fuer die Kalibrierung
	short	lOffStd;	// Standartwerte fuer die Kalibrierung
	short	lFullStd;	// Standartwerte fuer die Kalibrierung
	RD_CONST CENum	RD_MROM *elem;		// Zeiger auf zug. Element
    t_caliConvertFP fp_caliConvert; // Function pointer to conversion function
	Kali  	RD_MRAM *kali;		// Pointer to calibration
	} E_KALIIO;

typedef	struct {		//*** Timer
	unsigned short	index;		// Basisadresse des Timers
	unsigned short	adr;		// MEMIO-Adresse
	unsigned char	mode;		// Bit0: 0=off, 1=on	Bit1:	0=up, 1=down	 
	unsigned char	remanent;	// remanent-flag  
	long	rate;		// 
	RD_CONST CENum	RD_MROM *elem;		// Zeiger auf zug. Element
	long	act;
	long	old;
	long	subCounter;
	} E_TIM;

#if defined(___CTR___) && (RD_GAMMA != 0)
typedef struct { // Gamma - Elements
	const char *elemname;		// element name from the assign string, shall be transferred to Gamma functions for identification
	ga_PV pv;					// Element handle of Gamma, obtained e.g. from function ga_pv_open()
    char size;					// in bytes, negative values for signed, positive for unsigned
} E_GAMMA;
#endif // defined(___CTR___) && (RD_GAMMA != 0)

void saveNonval(char RD_MRAM *c);
void restoreNonval(char RD_MRAM *c);
void setupNonval(void);

#define	TIM_MODE_DOWN	2
#define	TIM_MODE_ON		1
#define	MAX_TIM_VALUE	999999999L
#define	MIN_TIM_VALUE	-999999999L

	
//**** Schrittmotor
typedef	struct {
	unsigned short	port;		/* Step-Hardware-Port			*/
	unsigned short	adr;		/* Step-Memoryadr.			*/
	short			fkt;		/* Faktor [stp/100mm]			*/
	long			min;		/* Step-MIN-Pos.			*/
	long			max;		/* Step-MAX-Pos.			*/
	unsigned char	i_run;		/* Laufstrom				*/
	unsigned char	i_stop;		/* Standstrom				*/
	unsigned char	exist;		/* Motor vorhanden			*/
	unsigned char	dout;		/* Digital-OUT				*/
	short			res;		/* Aufl?sung Stp/mm			*/
	long			pos;		/* Position in mm			*/
	unsigned char	v;		/* Geschwindigkeit			*/
	unsigned char	a;		/* Beschleunigung			*/
	long	tim;		/* Zeit, wie lange Motor schon steht	*/
	CElement RD_MROM	*elem;		// Zeiger auf zug. Element
	} E_STP;





typedef	struct {
	char			*s;
	unsigned short	l;
	} STRING;


typedef struct {		// def. of a printer-configuration
	STRING			textInst;	// text install
	STRING			textUnin;	// text uninstall
	STRING			lineInst;	// installation of a line
	STRING			lineUnin;	// uninstallation of a line 

	STRING			setCol1;	// command for color-select
	unsigned char	txtCol[16];	// table for 16 text colors (backgr.)
	STRING			setCol2;	// command for color-select

	STRING			*setFont;	// sequences for font selection
	} PCONF;



//*** CAN-Receive Buffer und Empfangs-Queue
typedef struct  	
{
	unsigned char	frame;		// frame unsigned char
	unsigned char	id[4];		// 4 ID-unsigned char (extended mode)
	unsigned char	data[8];	// 8 message bytes
} CanRecBuf;
	

/*************************************************************************/
/* function declarations                                                 */
/*************************************************************************/

void SetIO(short type, short adr, short val, short bitno);
unsigned char	di_test(IO_const E_DI RD_MIO *);
void			di_force(IO_const E_DI RD_MIO *e, unsigned char x);
short			di_isforced(IO_const E_DI *e);
void			di_unforce(IO_const E_DI RD_MIO *e);
void			di_logik(IO_const E_DI RD_MIO *,short);
void			do_set(IO_const E_DO RD_MIO *);
void			do_res(IO_const E_DO RD_MIO *);
void			do_inv(IO_const E_DO RD_MIO *);
void			do_write(IO_const E_DO RD_MIO *, unsigned char);
unsigned char	do_test(IO_const E_DO RD_MIO *);
void			do_logik(IO_const E_DO RD_MIO *,short);
short			do_isforced(IO_const E_DO RD_MIO *e);
void			do_force(IO_const E_DO RD_MIO *, unsigned char);
void			do_unforce(IO_const E_DO RD_MIO *);
short			ao_isforced(E_AO RD_MIO *ao);
void			ao_force(E_AO RD_MIO *ao, short val);
void			ao_unforce(E_AO RD_MIO *ao);
short			ao_getforce(E_AO RD_MIO  *ao);
void			ao_write(E_AO RD_MIO *ao, short val);
short			ao_read(E_AO RD_MIO *ao);
short			ai_isforced(E_AI RD_MIO *ai);
void			ai_force(E_AI RD_MIO *ai, short val);
void			ai_unforce(E_AI RD_MIO *ai);
short			ai_read(E_AI RD_MIO *ai);
short			cnt_isforced(E_CNT RD_MIO *cnt);
void			cnt_force(E_CNT RD_MIO *cnt, short val);
void			cnt_unforce(E_CNT RD_MIO *cnt);
long			cnt_read(E_CNT RD_MIO  *);

void			do_exe_set(IO_const E_DO RD_MIO *);
void			do_exe_res(IO_const E_DO RD_MIO *);
unsigned char	di_exe_test(IO_const E_DI *e);
void			ao_exe_write(E_AO RD_MIO  *, short);
short			ai_exe_read(E_AI RD_MIO *ai);
long			cnt_exe_read(E_CNT RD_MIO *cnt);

short			ao_readP(E_AO* eao);
#ifndef ai_readP
	short	ai_readP(E_AI RD_MIO  *);
#endif
void	ai_writeP(E_AI RD_MIO  *, short);
long	cnt_readP(E_CNT RD_MIO  *);
void	cnt_writeP(E_CNT RD_MIO  *, long);
void	cnt_updateP(E_CNT RD_MIO *cnt, long val);

void	ti_write(E_TIM  RD_MIO  *, long);
long	ti_read(E_TIM RD_MIO  *);
void	ti_off(E_TIM RD_MIO  *);
void	ti_on(E_TIM RD_MIO  *);
void	ti_count(E_TIM RD_MIO  *);


//*** falls dieses bit 0 ist, wird das element in der kalibrierfunktion nicht beruecksichtigt
#define	IO_ENABLEBIT_KALI		1
//*** falls dieses bit 0 ist, wird das element in der diagnosefunktion nicht beruecksichtigt
#define	IO_ENABLEBIT_DIAG		2
//*** falls dieses bit 0 ist, wird das element in der protokollfunktion nicht beruecksichtigt
#define	IO_ENABLEBIT_PROT		4
//*** falls dieses bit 0 ist, stehen die Kaliwerte nicht im eeprom
#define	IO_ENABLEBIT_KALIFIX	128

//*** Element soll in der Kalibrierfkt. nur auftauchen wenn beide bits gesetzt sind
#define KALI_MASK	(IO_ENABLEBIT_KALI+IO_ENABLEBIT_KALIFIX)

void	ai_set_access(E_AI RD_MIO *,short mask);
void	ai_res_access(E_AI RD_MIO *,short mask);
short	ai_test_access(E_AI RD_MIO *,short mask);
short	get_enabled_ai_num(short mask);
E_AI RD_MIO *	get_enabled_ai(short pos, short mask);

void	ao_set_access(E_AO RD_MIO *,short mask);
void	ao_res_access(E_AO RD_MIO *,short mask);
short	ao_test_access(E_AO RD_MIO *,short mask);
short	get_enabled_ao_num(short mask);
E_AO RD_MIO *	get_enabled_ao(short pos, short mask);

void	cnt_set_access(E_CNT RD_MIO *,short mask);
void	cnt_res_access(E_CNT RD_MIO *,short mask);
short	cnt_test_access(E_CNT RD_MIO  *,short mask);
short	get_enabled_cnt_num(short mask);
E_CNT RD_MIO *	get_enabled_cnt(short pos, short mask);

extern	E_TIM	Systemtimer1;

//*** LPT (Centronics) ****
void	lptInit(void);		
short	lptChar(char);				// ret: 0=OK, sonst TIMEOUT
short	lptStr(char RD_MRAM *);				// ret: 0=OK, sonst TIMEOUT
short	lptStrlen(char RD_MRAM *, short len);	// ret: 0=OK, sonst TIMEOUT
short	lptStat(void);				// s.u.

#define	LPT_STAT_ERROR			0x01
#define	LPT_STAT_PAPEROUT		0x02
#define	LPT_STAT_OFFLINE		0x04
#define	LPT_STAT_NOT_CONNECTED	0x40
#define	LPT_STAT_BUSY			0x80

//*** Chipcard ****
short			card_state(void);
unsigned long	card_reset(void);
void    		card_command(unsigned char command, short address, unsigned char data);
short			card_read(   unsigned char command, short address, unsigned char RD_MRAM *b, short num);
short			card_write(  unsigned char command, short address, unsigned char data);
short			card_read28( unsigned char command, short address, unsigned char RD_MRAM *b, short num);
short			card_write28(unsigned char command, short address, unsigned char data);

//*** CAN ****
short			canInit(void);
unsigned char	canReadReg(unsigned char adr);
void			canWriteReg(unsigned char adr, unsigned char val);
short			canGetMessage(CanRecBuf RD_MRAM *);

//*** Interbus ****
void			ibInit(void);
void			ibAwake(void);
unsigned char	ibRead(short adr);
unsigned char	ibReadOut(short adr);
unsigned char	ibWrite(short adr, unsigned char value);


extern IO_const E_DI	RD_MIO tab_e_di[];
extern IO_const E_DO	RD_MIO tab_e_do[];
extern 			E_AI	RD_MIO tab_e_ai[];
extern 			E_AO	RD_MIO tab_e_ao[];
extern 			E_CNT	RD_MIO tab_e_cnt[];
extern			E_TIM	RD_MIO tab_e_tim[];
#ifndef ___CTR___
extern RD_CONST unsigned char   std_e_di[];
extern RD_CONST short           std_e_ai[];
extern RD_CONST short           std_e_ao[];
extern RD_CONST unsigned char   std_e_do[];
extern RD_CONST long            std_e_cnt[];
extern RD_CONST long            std_e_tim[];
#endif // ___CTR___
#if defined(___CTR___) && (RD_GAMMA != 0)
extern          E_GAMMA RD_MIO  tab_e_gamma[];
extern RD_CONST short   G_numGammaElems;
#endif // defined(___CTR___) && (RD_GAMMA != 0)


extern RD_CONST short	NumEcnt;
extern RD_CONST short	NumEdi;
extern RD_CONST short	NumEdip;
extern RD_CONST short	NumEdo;
extern RD_CONST short	NumEdop;
extern RD_CONST short	NumEao;
extern RD_CONST short	NumEai;


typedef struct {
	void RD_MRAM *pnt;		// points to the value in the global structure
	unsigned char size;		// Abhaengig von CTR-setting PE. Bei PE=0 nur Groesse ansonsten
							// Bit0..3 = Datumsgroesse in Byte, Bit4: 1=Fliesskomma, Bit5..7: Assigntyp mit
							// 1=Param, 2=Syspar, 3=Proc, 0=sonstige   
	unsigned char mask;		// Bitmaske fuer Comtype E: 1=E1,2=E2,4=E3,8=E4,...
#if USE_INSTANCE_ARRAY != 0
	unsigned char isoffset; // 1 if pnt is offset in global structure else 0
#endif // USE_INSTANCE_ARRAY
} RD_IDX_PNT_TAB;

#define	RD_IDX_PNT_SizeMask	0x01f


typedef struct {
	short off;
	unsigned char size;		// Abhaengig von CTR-setting PE. Bei PE=0 nur Groesse ansonsten
							// Bit0..3 = Datumsgroesse in Byte, Bit4: 1=Fliesskomma, Bit5..7: Assigntyp mit
							// 1=Param, 2=Syspar, 3=Proc, 0=sonstige
	unsigned char mask;		// Bitmaske fuer Comtype E: 1=E1,2=E2,4=E3,8=E4,
} RD_IDX_OFF_TAB;

typedef struct {
		CElement RD_MROM *pnt;	// Pointer to Element
		struct S_Modul RD_MROM *mpnt;	// Pointer to Module containing the Element
} RD_IDX_PNT_PRSV_TAB;

#ifdef RD_AUTOTEST_ON		
	
	//***************** Hardwaretest ***********************************
	enum TESTTYPE {		// Attribute:
		PUT_DO,			// Port, <0/1>, -, 
		PUT_AO,			// Port, <val>, -, 
		PUT_CNT,		// Port, <val>, -, 
		TEST_DI,		// Port, <0/1>, -, 
		TEST_AI,		// Port, <lower val>, <higher val>,
		TEST_CNT,		// Port, <lower val>, <higher val>,
		TEST_DISP,		// NULL, <picture>, -,
		TEST_KEY,		// NULL, <key>, -,
		KALI_AI,		// Port, <lower val>, <higher val>,
		KALI_CNT,		// Port, <lower val>, <higher val>,
		MESSAGE,		// Meldung
		TESTEND };		// Test-Ende
	
	#ifdef ___CTR___			// Instruktion-Text auf dem Target nicht uebernehmen
		#define	INSTR(txt)	""
	#else
		#define	INSTR(txt)	txt
	#endif
		
	#define	CONT_KEY	0x100	// weiter, wenn eine bel. Taste betaetig wird
	#define	CONT_OK		0x200	// weiter, wenn Test OK ist
	
	typedef struct {
		short	action;
		void	*ea;
		long	value1;
		long	value2;
		short	cont;		// falls HIGH-Byte == 0 dann LOW-Byte: 1-255 = 0.1-25.5s warten (ohne Bedingung)
							// falls HIGH-Byte == CONT_KEY oder CONT_OK dann LOW-Byte Timeout 
		char	*mess;
		} RD_HWAT;	
		
#endif


#endif //  _ctr_io_
