//
// $Id: ctr_mod.h 9238 2016-09-23 06:34:52Z afoltinek $
//
// Copyright (c) IMACS GmbH Germany. All rights reserved.
//

#ifndef __CTR_MOD_H__
#define __CTR_MOD_H__

#if (USE_INSTANCE_ARRAY != 0) && (USE_RDI_INDEX == 0)
	#error Usage of module pointers without RDIs not possible. Please enable RDIs.
#endif

struct S_Surface
{
	struct S_Surface RD_MROM *next;
	XPTR vis;
	XPTR def;
};

typedef struct S_Surface CSurface;



//*** basic structure for all generated modul structues (modul handles)
struct S_Modul 
{
	struct S_Modul	RD_MROM 	*next;			// next module instance in same hierarchie level 
	struct S_Modul	RD_MROM 	*submodul;		// first module instance (of chain) in sub level of this modul  
	struct S_Modul	RD_MROM 	*topmodul;		// top module	
	CElement RD_MROM 			*element;		// Zeiger auf den ersten Handle der Elemente des Moduls
	CSurface RD_MROM 			*surface;		// first SurfaceCtr (of chain) in this modul
	char (*elemtab)(short elind, long RD_MRAM *elemPnt); //

	XPTR						def;			// Reference / handle to the module definition 
	short						NodeID;			//
	#if USE_INSTANCE_ARRAY != 0
		RD_CONST short RD_MROM 			*accesstab;	//
	#endif
};

typedef struct S_Modul CModul;



#if USE_RDI_INDEX != 0
	extern short G_targetIdx;	// Kommunikationsindex der aktuellen Modul-Array-Instanz
										// wird ausschliesslich fuer die Target/Target-Kommunikation verwendet
										// highbyte is the NodeID of the actual module
										// lowbyte is "der elemtabIdx aus der pnttab"
#endif


#if USE_INSTANCE_ARRAY != 0
	
	// Struktur zur Verwaltung eines instanzierten Modules (eines Instanzarrays)
	typedef struct {
		short	modIdx;					// Instanzkennummer 
		short	elemtabIdx;				// 
		void	RD_MRAM *data;			// 
		RD_IDX_PNT_TAB	RD_MROM *pnttab;//
	} Pnt_Array;
	

	extern Pnt_Array RD_MRAM * RD_MROM G_Procpnt[MAXPNTARRAYDEPTH]; // Pointer to current instance array
										// Attention: G_Procpnt is used for process code
    extern unsigned char G_CurPntDepth; // Current index for pointer to current instance array

	extern void	RD_MRAM *G_actdata;	
										// Achtung: G_actdata wird nur fuer die Oberflaeche verwendet

	extern short G_Index;				// Index (z.B. das aktuelle i von sl[i]) der aktuellen Modul-Array-Instanz

	extern RD_MROM CElement ** RD_MROM Elemente_der_Unbestimmten_Module[];

	extern short RD_MROM				InstArray_MaxLen[];			// Array in dem die Groesse (max. moegl. Index) der einzelnen Instanzarrays abgelegt sind 
	extern RD_CONST RD_IDX_PNT_TAB RD_MROM	*otherPnttabs[];			//
	extern CModul RD_MROM * RD_MROM		Unbestimmte_Module[];		//
	extern Pnt_Array RD_MRAM * RD_MROM	InstArray_Module[];			//
	extern short RD_MRAM * RD_MROM		InstArray_Indizes[];		//

    Pnt_Array RD_MRAM *getSurInstArrPnt(short accessType, short index, char surStackIndex);
    Pnt_Array RD_MRAM *getProcInstArrPnt(short accessType, short index);
	void RD_MRAM *getDataStruct(M_D_SCR short zugriffsnr, char surStackIndex);
	void SetElemDBDataViaPntTab(long actval, short rdi_index);
#endif



//*** Schnittstelle zur Datenbank *************************************

// structure for embedded database	
typedef struct 
{
	CElement	RD_MROM *element;	//
	short		comTypeD;			// 
	short		zugriffsnr;			// Verwendung: 0 => Elem nicht im Instanzarray, x>0 => Element in dem Instanzarray x verwaltet
									// Hinweis: es koennen mehrerer Instanzarrays zugleich verwaltet werden 
} CEmb_Database;


void PutElemDBData(unsigned char RD_MRAM *dataPnt, short datalen);
short GetElemDBDataByComType(unsigned char RD_MRAM *dataPnt, short bytebufferlen, short mtype);
short GetElemDBDataByModul(unsigned char RD_MRAM *dataPnt, short bytebufferlen, CModul RD_MROM *mod);


extern CEmb_Database  RD_MROM DatenbankElemente[];
extern RD_IDX_PNT_TAB RD_MCOM *DatenbankIdxPntTab;



	
XPTR CModul_getVisIdx(CModul RD_MROM *mod, short snr);
CElement RD_MROM *CModul_getElem(M_D_SCR short snr);
CSurface RD_MROM *CModul_getSurface(RD_CONST CModul RD_MROM *mod, short snr);
void CModul_getDesc(RD_CONST CModul RD_MROM *mod, RD_char RD_MRAM *buf);
void CModul_getName(RD_CONST CModul RD_MROM *mod, RD_char RD_MRAM *buf);
void CSurface_getDesc(CSurface RD_MROM *sur, RD_char RD_MRAM *buf);
XPTR CSurface_getVisIdx(CSurface RD_MROM *sur,short nr);
short CSurface_getSurfaceNr(CSurface RD_MROM *sur);

void CModul_updateOldVal(CModul RD_MROM *mod);


void setupAll(M_D_SCR CModul RD_MROM *mod, short parsys);
void doSurInterpreter(M_D_SCR_S);
void pushSurfaceStack(M_D_SCR_S);
void popSurfaceStack(M_D_SCR_S);
void ShowDialog(M_D_SCR CModul RD_MROM *modul, short surNr);

extern RD_CONST CModul	RD_MROM * RD_MROM modultabelle[];
extern RD_CONST CElement RD_MROM * RD_MROM elementtabelle[];
extern RD_CONST CModul RD_MROM *pGRoot; //*** globaler zeiger auf das rootmodul des projektes

extern RD_CONST short RD_MROM maxlines;
extern RD_CONST short RD_MROM maxcolumns;

extern RD_CONST short Act_Height;
extern RD_CONST short NumMenuMax;

extern short GActLanguageBank;//*** nummer der sprachbank (korrigiert bzgl. der wirklich vorhanden sprachen
extern short GActLanguage;    //*** eigentliche sprachnummer (0=GR, 1=UK, 2=FR, ...)

extern void RD_MRAM *GEepSys; //*** wird zur laufzeit geaendert

#if NO_EMB_HMI == 0
#ifdef T_KEY_ABORT
	extern RD_CONST short G_sur_key_abort;
	extern RD_CONST short G_t_key_abort;
#endif
#endif
extern RD_CONST short G_numAKeyGlo;
extern RD_CONST short G_maxAnzBarVis;
extern RD_CONST short G_maxAnzVis;
#if RD_NO_BLINK == 0
	extern RD_CONST short G_Blink_Freq;
	extern RD_CONST short G_Blink_Type;
#endif // RD_NO_BLINK == 0
#ifndef ___CTR___
	extern RD_CONST short GInter_Rate;
	extern RD_CONST short G_maxAnzScreens;
#endif // ___CTR___
extern RD_CONST unsigned long GLang_enable[];
//extern RD_CONST unsigned long GLang_enable1;
//extern RD_CONST unsigned long GLang_enable2;
//extern RD_CONST unsigned long GLang_enable3;
//extern RD_CONST unsigned long GLang_enable4;
extern RD_CONST short GDevice_id;
extern RD_CONST short GWrong_pwd;
extern RD_CONST short GZugang_verw;
extern RD_CONST short GSave_mit;
extern RD_CONST short GBerechtigung;
extern RD_CONST short GTxtEingeben;
extern RD_CONST short GTxtEingeben_S;
extern RD_CONST short GSpeichern;
extern RD_CONST short GSpeichern_s;
extern RD_CONST short GExecute;
extern RD_CONST short GExecute_s;
extern RD_CONST short GTastetippen;
extern RD_CONST short GTastetippen_s;
extern RD_CONST short GStandartwert;
extern RD_CONST short GBereich;
extern RD_CONST short GElemHelp;
extern RD_CONST short GBereichsfehler;
extern RD_CONST short GGewaehlterwert;
extern RD_CONST short GDelete;
extern RD_CONST short GDelete_s;
extern RD_CONST short GZeit;
extern RD_CONST short GEdit_mit;
extern RD_CONST short GDatum;
extern RD_CONST short GTxt_ja;
extern RD_CONST short GTxt_nein;
extern RD_CONST short GJa_enter;
extern RD_CONST short GNicht_editierbar;
extern RD_CONST short GNicht_editierbar_s;
extern RD_CONST short GMenuhelp;
extern RD_CONST short GFehler;
extern RD_CONST short GZul_bereich;
extern RD_CONST short GKein_device;
extern RD_CONST short GZeichen;
extern RD_CONST short GKrit_funk1;
extern RD_CONST short GKrit_funk2;
extern RD_CONST short GKrit_funks;
extern RD_CONST short	GXTXT_KaliEditTLow;
extern RD_CONST short	GXTXT_KaliEditTHigh;
extern RD_CONST short	GXTXT_KaliEditLogH;
extern RD_CONST short	GXTXT_KaliEditLogL;
extern RD_CONST short	GXTXT_KaliEditPhyH;
extern RD_CONST short	GXTXT_KaliEditPhyL;
extern RD_CONST short	GXTXT_KaliLogH;
extern RD_CONST short	GXTXT_KaliLogL;
extern RD_CONST short	GXTXT_KaliPhyH;
extern RD_CONST short	GXTXT_KaliPhyL;
extern RD_CONST short	GXTXT_KaliTeachHigh;
extern RD_CONST short	GXTXT_KaliTeachStandard;
extern RD_CONST short	GXTXT_KaliTeachLow;
extern RD_CONST short    GXTXT_KaliSetActPhys;


extern RD_CONST void RD_MRAM *GFlag;
extern RD_PROC RD_MRAM * RD_CONST GProc;
extern RD_PROC RD_MRAM * RD_CONST GProcCopy;
extern PARAM RD_MRAM * RD_CONST GParam;
extern SYSTEM RD_MRAM * RD_CONST GSystem;
extern long	RD_MRAM * RD_CONST GRemanent ;
extern long	RD_MRAM * RD_CONST GRemanentCopy ;

#if ((NO_EMB_HMI == 0) && (RD_NO_EDIT_COPY == 0))
//	extern EEP_Kali RD_MRAM * RD_CONST GKaliEd;	// defined in include_all.h due to location of typedef EEP_Kali
	extern PARAM RD_MRAM * RD_CONST GParamEd;
	extern SYSTEM RD_MRAM * RD_CONST GSystemEd;
#endif

extern RD_CONST void RD_MROM *GInitProc;
extern RD_CONST void RD_MROM *GInitParam;
extern RD_CONST void RD_MROM *GInitSystem;
extern RD_CONST void RD_MROM *GInitFlag;

extern RD_CONST short GProcSize;
extern RD_CONST short GProcVers;
extern RD_CONST short GParamSize;
extern RD_CONST short GParamVers;
extern RD_CONST short GParamAlignCorr;
extern RD_CONST short GSystemSize;
extern RD_CONST short GSystemVers;
extern RD_CONST short GKaliSize;
extern RD_CONST short GKaliVers;
extern RD_CONST short GTouchVers;
extern RD_CONST short GAlignment;
extern RD_CONST short GFlagSize;
extern RD_CONST short GSoftVers;
extern RD_CONST short GTimerNumber;
extern RD_CONST short GSaveMenuPos;
extern RD_CONST short GSubtextNumber;
extern RD_CONST short GremanentLen;

#if RD_NO_COMMUNICATION == 0
extern unsigned long usCommBlock[];
#endif
#if ((!defined(___CTR___)) || (RD_NO_COMMUNICATION == 0))
extern RD_CONST short GComFlagSize;
extern RD_CONST short G_IOSize;
#endif

extern	CElement RD_MRAM* pGPassUser;
extern	CElement RD_MRAM* pGPassAdmin;
extern	CElement RD_MRAM* pGPassTech;
extern	CElement RD_MRAM* pGPassSuper;
extern	CElement RD_MRAM* pGSound;
extern	CElement RD_MROM* pGLanguage;
extern	CElement RD_MRAM* pGVersSys;
extern	CElement RD_MRAM* pGVersKali;
extern	CElement RD_MRAM* pGVersSoft;
extern	CElement RD_MRAM* pGVersPar;
extern	CElement RD_MRAM* pGVersProc;

extern long ElemNumbers[];
extern char NodeNames[];
extern char* ModuleNames; 
extern long G_anzSignalebenen;
extern long G_anzSM;
extern long G_anzCFunc;
extern long G_anzActivity;
extern long G_anzSeqDiagram;

extern RD_CONST XPTR GP_Lock;
extern RD_CONST XPTR GP_Info;
extern RD_CONST XPTR GP_Conti;
extern RD_CONST XPTR GP_Abort;
extern RD_CONST XPTR GP_Factory;
extern RD_CONST XPTR GP_Back;
extern RD_CONST XPTR GP_Enter;
extern RD_CONST XPTR GP_Stop;
extern RD_CONST XPTR GP_Black;
extern RD_CONST XPTR GP_EditNum;
extern RD_CONST XPTR GP_EditTim;
extern RD_CONST XPTR GP_EditStr;
extern RD_CONST XPTR GP_EditBin;
extern RD_CONST XPTR GP_EditDat;
extern RD_CONST XPTR GP_Attention;
extern RD_CONST XPTR GP_No;
extern RD_CONST XPTR GP_Yes;
extern RD_CONST XPTR GP_Question;
extern RD_CONST XPTR GP_KaliAI;
extern RD_CONST XPTR GP_KaliAO;
extern RD_CONST XPTR GP_Kali_L;
extern RD_CONST XPTR GP_Kali_H;
extern RD_CONST XPTR GP_Manuell;
extern RD_CONST XPTR GP_StepInc;
extern RD_CONST XPTR GP_FactManu;
extern RD_CONST XPTR GP_CaliUpDn;
extern RD_CONST XPTR GP_DiagDI;
extern RD_CONST XPTR GP_DiagDO;
extern RD_CONST XPTR GP_DiagAI;
extern RD_CONST XPTR GP_MessAI;
extern RD_CONST XPTR GP_DiagAO;
extern RD_CONST XPTR GP_MessAO;
extern RD_CONST XPTR GP_BKali;
extern RD_CONST XPTR GP_DiagCnt;
extern RD_CONST XPTR GP_KaliCnt;
extern RD_CONST XPTR GP_MessCnt;
extern RD_CONST XPTR GP_SetFactory;
extern RD_CONST XPTR GP_SetRange;
extern RD_CONST XPTR GP_Roll;

// Offsets in ext. Flash.
extern unsigned long GFlashOffset_ini ;
extern unsigned long GFlashOffset_bmp ;
extern unsigned long GFlashOffset_txt ;

#endif // __CTR_MOD_H__
