//
// $Id: ctr_vis.h 9238 2016-09-23 06:34:52Z afoltinek $
//
// Copyright (c) IMACS GmbH Germany. All rights reserved.
//

#ifndef _ctr_vis_h_
#define _ctr_vis_h_

//*********************************************************************************************
// Macros
//*********************************************************************************************


#if NO_EMB_HMI == 0
#ifdef T_KEY_ABORT
	void	resetAbort(void);		// Auto-Ruecksprung steuern
	void	setAbort(short);		// Auto-Ruecksprung aktivieren
	short	testAbort(void);		// Auto-Ruecksprung aktiv???
	extern E_TIM timKeyAbort;		// Timer for automatic abort
#endif
#endif

#ifndef RD_GM
#define RD_GM(p) p
#endif
#ifndef RD_GS
 #define RD_GS(p) p
#endif
#ifndef RD_GV
 #define RD_GV(p) p
#endif





//*** MENU_ZERO_REDRAW benutzen, fuer den fall, dass menueposition 0 neu gezeichnet werden muss
#define MENU_ZERO_REDRAW 	-100

//*** Menueoptionen *****************
#define	MENU_CURSOR			1
#define	MENU_BLINK			2
#define	MENU_INVERT			3
#define MENU_INVERT_LINE    4
#define MENU_INVERT_GRALINE 5
#define MENU_USER_CURSOR    6

#define	MENU_SCROLL_LR				0x0100		// Menu scrollen mit LEFT/RIGHT
#define	MENU_SCROLL_ROLL			0x0200		// am unteren Ende des Menues automatisch zum ersten Punkt springen
#define	MENU_DIRECT_AUTOEX			0x0400		// Verlassen der Surface bei Weiternavigation ueber die Grenzen hinaus
//		RD_MENUUSERSCROLLBAR		0x800		// Userdefined scrollbar in menu
#define MENU_COLUMN_ROLL			0x1000		// Jump back to first column after last column
//		RD_MENUSCROLLBAR			0x2000		// Scrollbar in Menue darstellen (wird automatisch von der Common gesetzt)
#define MENU_COLCHANGE_FIRSTLINE	0x4000		// Select first line after column change
#define MENU_COLCHANGE_USERDEFINED	0x8000		// Use user defined function for line selection of column change

#define MENU_STEP_SEARCH	0 // To search for a menu item regardless of row/column
#define MENU_STEP_DOWN		1
#define MENU_STEP_UP		-1
#define MENU_STEP_RIGHT		2
#define MENU_STEP_LEFT		-2

#define RD_SINGLESTEP       0
#define RD_HALFPAGE         1
#define RD_FULLPAGE         2
#ifndef RD_MENU_SCROLL_TYPE
	#define RD_MENU_SCROLL_TYPE RD_HALFPAGE
#endif

// Macros zum Handling der VariablenPools
extern RD_CONST VARPOOL_IDX GVarPoolUniqueOffset;
#if RD_NO_FULL == 0
#define GETVARPOOLVALUE(type, idx)  	(*((type RD_MRAM *)(((char*)G_VarPool) + idx + RDFullOffset)))
#define GETPROPVARPOOLVALUE(type,idx)   (*((type RD_MRAM *)(((char*)G_PropVarPool) + idx + RDFullPropOffset)))
#else // RD_NO_FULL
#define GETVARPOOLVALUE(type, idx)  	(*((type RD_MRAM *)(((char*)G_VarPool) + idx)))
#define GETPROPVARPOOLVALUE(type,idx)   (*((type RD_MRAM *)(((char*)G_PropVarPool) + idx)))
#endif // RD_NO_FULL == 0
#define GETUNIQUEPOOLVALUE(type, idx)   (*((type RD_MRAM *)(((char*)G_VarPool) + GVarPoolUniqueOffset + idx)))

#define   VARPOOLCHAR(idx)			GETVARPOOLVALUE(char, idx)
#define   VARPOOLUCHAR(idx)			GETVARPOOLVALUE(unsigned char, idx)
#define   VARPOOLSHORT(idx)			GETVARPOOLVALUE(short, idx)
#define   VARPOOLUSHORT(idx)		GETVARPOOLVALUE(unsigned short, idx)
#define   VARPOOLLONG(idx)			GETVARPOOLVALUE(long, idx)
#define   VARPOOLULONG(idx)			GETVARPOOLVALUE(unsigned long, idx)
#define   PROPVARPOOLCHAR(idx)		GETPROPVARPOOLVALUE(char, idx)
#define   PROPVARPOOLUCHAR(idx)		GETPROPVARPOOLVALUE(unsigned char, idx)
#define   PROPVARPOOLSHORT(idx)		GETPROPVARPOOLVALUE(short, idx)
#define   PROPVARPOOLUSHORT(idx)	GETPROPVARPOOLVALUE(unsigned short, idx)
#define   PROPVARPOOLLONG(idx)		GETPROPVARPOOLVALUE(long, idx)
#define   PROPVARPOOLULONG(idx)		GETPROPVARPOOLVALUE(unsigned long, idx)

//****** Macros zum Handling der bedingten Oberflaeche
// es existiert jewels die Bitkette 1 (akt. Freigabezustand) und Bitkette 2 (alter Freigabezustand)
//
// Zeigervar. zur Verfuegung stellen
#define LOCALSURVAR		unsigned char RD_MRAM *LocalSurEnIdx1=NULL; unsigned char RD_MRAM *LocalSurEnIdx2=NULL; short LocalSurEnMask=0;

void	RDSUREN_INIT(M_D_HMIID);

#ifdef ___CTR___
	// aktuellen Zustand der Bitketten speichern (in lokalen Vars., die mit LOCALSURVAR angelegt wurden)
	#define	RDSUREN_SAVE(a)	{ LocalSurEnIdx1 = RdSurEnIdx1[0]; LocalSurEnIdx2 = RdSurEnIdx2[0]; LocalSurEnMask = RdSurEnMask; }
	// gespeicherten Zustand zurueckholen
	#define	RDSUREN_REST(a)	{ RdSurEnIdx1[0] = LocalSurEnIdx1; RdSurEnIdx2[0] = LocalSurEnIdx2; RdSurEnMask = LocalSurEnMask; }

	#define	RDSUREN1(a)		(*(RdSurEnIdx1[0]) & RdSurEnMask)
	#define	RDSUREN2(a)		(*(RdSurEnIdx2[0]) & RdSurEnMask)
#else
	// aktuellen Zustand der Bitketten speichern (in lokalen Vars., die mit LOCALSURVAR angelegt wurden)
	#define	RDSUREN_SAVE(nr)	{ LocalSurEnIdx1 = RdSurEnIdx1[nr]; LocalSurEnIdx2 = RdSurEnIdx2[nr]; LocalSurEnMask = RdSurEnMask; }
	// gespeicherten Zustand zurueckholen
	#define	RDSUREN_REST(nr)	{ RdSurEnIdx1[nr] = LocalSurEnIdx1; RdSurEnIdx2[nr] = LocalSurEnIdx2; RdSurEnMask = LocalSurEnMask; }

	#define	RDSUREN1(nr)		(*(RdSurEnIdx1[nr]) & RdSurEnMask)
	#define	RDSUREN2(nr)		(*(RdSurEnIdx2[nr]) & RdSurEnMask)
#endif

#define	RDSUREN_SET1_L		*LocalSurEnIdx1 |= LocalSurEnMask;
#define	RDSUREN_RES1_L		*LocalSurEnIdx1 &= ~LocalSurEnMask;
#define	RDSUREN_SET2_L		*LocalSurEnIdx2 |= LocalSurEnMask;
#define	RDSUREN_RES2_L		*LocalSurEnIdx2 &= ~LocalSurEnMask;

#define CONDTYPE_IF		0
#define CONDTYPE_ELSE	1
#define CONDTYPE_ENDIF	2

//*********************************************************************************************
// Types
//*********************************************************************************************

struct S_AKeyGlobal
{
	RD_CONST struct S_Modul RD_MROM *mod;			// Modul in dem die AKEYGLOBAL definiert wurde
	short surnr;									//    zug. Oberflaechennummer
	short key;										// Ausloese-Tastencode
	XPTR visIdx;									// Zeiger auf das Vis-Obj.
	short ruecksprung;								// 0 = kehrt nach Ausfuehrung wieder an die alte HMI-Stelle zurueck
													// 1 = springt (nur) an die Stelle, an der die AKEYGLOBAL definiert wurde
													// dies wird ueber die SurfaceNr. der Zieloberflaeche bestimmt und
													// vom Designcompiler automatisch generiert
													// falls (ZielSurfaceNum >= 5000) => dann ist ruecksprung = 0, sonst 1
};
typedef struct S_AKeyGlobal CAKeyGlobal;


struct S_SurStack
{
    EMB_HMI   screen;
    XPTR	  nextActionIndx;
    short     key;
};
typedef struct S_SurStack CSurStack;


//*********************************************************************************************
// Functions
//*********************************************************************************************


//*** in project.io:
// EN1=0 und EN2=0: 0=Aus
// EN1=1 und EN2=0: 1=Ein -> muss nur geupdated werden
// EN1=0 und EN2=1: 2=eben neu eingeschaltet worden -> muss gedrawt (->1) und geupdated werden
//*** extern unsigned char RdSurEnBuf1[][MAXANZVIS_ARRAYLEN];
//*** extern unsigned char RdSurEnBuf2[][MAXANZVIS_ARRAYLEN];


// Zeiger auf des erstes byte der enable-arrays, werden beim systembooten fix initialisiert
extern unsigned char RD_MRAM *RdSurEnIdx1Start;
extern unsigned char RD_MRAM *RdSurEnIdx2Start;

// zeiger auf das aktuelle byte in den enable-arrays
extern unsigned char RD_MRAM *RdSurEnIdx1[];
extern unsigned char RD_MRAM *RdSurEnIdx2[];


extern short RdSurEnMask; // aktuelle bitmaske
extern short RDDebugIdx; // debug-info


//void print_save_str(short RD_MRAM *x, short RD_MRAM *y, char RD_MRAM *wstr);
//void debugl(M_D_SCR long wert,short len,short height);
//void debugl2(M_D_SCR long wert,short len,short height);
//void editcursor(short xpos, short ypos, short stelle, char RD_MRAM *s);
void edit_num(int ox,int oy, char RD_MRAM *str,int form,char RD_MRAM *range,int xmode);

void draw_object(M_D_SCR XPTR index, short x, short y);
void draw_pict(M_D_SCR short x, short y, XPTR id);
#if RD_EXTGRA != 0
void draw_object_rot(M_D_SCR XPTR index, short x, short y, long rotkangle);
#endif // RD_EXTGRA != 0
void Icon_info(M_D_SCR_S);
void Icon_back(M_D_SCR_S);
void Icon_stepinc(M_D_SCR_S);
void Icon_enter(M_D_SCR_S);
void Icon_stop(M_D_SCR_S);
void Icon_enum(M_D_SCR_S);
void Icon_ebin(M_D_SCR_S);
void Icon_estr(M_D_SCR_S);
void Icon_etim(M_D_SCR_S);
void Icon_edat(M_D_SCR_S);
void Icon_reset(M_D_SCR_S);
void Icon_resetR(M_D_SCR_S);
void Standardpage(void);
void longBeep(void);
void shortBeep(void);
void setMenuCursorPosition(short column, short line);


short initNewSur(M_D_SCR short surNr);

#ifdef RD_SURFACE_SUSPEND
	void surfaceSuspendA(void); // to detect the first function call of surfaceSuspend in doSurInterpreter()
	void surfaceSuspend(void);
#endif

extern unsigned char IniBinaries[];
extern unsigned char TxtBinaries[];
extern unsigned char *BmpBinaries;

#ifdef IMACS_01
	long 			farp2long(void RD_MBIN *ptr);
	void RD_MBIN	*long2farp(long l);
#endif

void area_object(M_D_SCR union UVisObj RD_MBIN *item, short RD_MRAM *px1, short RD_MRAM *py1, short RD_MRAM *px2, short RD_MRAM *py2);


short testPassword(M_D_SCR short level);
void resetPassword(void);

#if RD_NO_BLINK == 0
	extern CElement RD_MROM *RD_Blinkelem;
	extern CElement RD_MROM *RD_Blinkelem_old;
#endif


extern short RD_MRAM MenuPosArray[];

extern short RD_MRAM BarVisOldArray[];		//afo

extern RD_char RD_MRAM RD_Global_wstr[];
extern RD_char RD_MRAM RD_Global_wstr1[];
extern RD_char RD_MRAM RD_Global_wstr2[];
extern RD_char RD_MRAM RD_Global_wstr3[];


#if NO_EMB_HMI == 0


//*********************************************************************************************
//*** V I S U A L I S I E R E R
//*********************************************************************************************


extern unsigned long G_VarPool[];
extern RD_CONST VARPOOL_IDX GUniquePoolOffset;
#if RD_PROPFONT != 0
extern unsigned long G_PropVarPool[];
extern RD_CONST short GPropPoolSize;
#endif // RD_PROPFONT != 0

short condition(M_D_SCR XPTR visIdx, short upperEnable);
short initMenu(M_D_SCR XPTR visIdx);
void initSur(M_D_SCR XPTR rootvisIdx, short z);

extern RD_CONST CAKeyGlobal RD_MROM AKeyGlobal_tab[];


// Surface-Stack-Handling
extern char G_ActSurStack;
extern CSurStack RD_MRAM surfaceStack[RD_SURSTACKSIZE];


void add2FullArray(M_D_SCR DVisFull RD_MBIN *visfull);
void removeFromFullArray(M_D_SCR_S);


short doActions(M_D_SCR XPTR action, short key);

XPTR UVisObj_next(RD_OSDL_PNT(union UVisObj, vis) M_D_HMIID_KV);
void UVisObj_getPos(union UVisObj RD_MBIN *vis, short RD_MRAM *px, short RD_MRAM *py);
void menuItem_getPos(short index, short RD_MRAM *px, short RD_MRAM *py);
void UVisObj_setPosMenu(M_D_SCR union UVisObj RD_MBIN *vis, short index);
CModul RD_MROM *getModulePointer(M_D_SCR short modnummer);
short getAnzMItems(DVisMenuBegin RD_MBIN *thisvis);
short UVisObj_execute(M_D_SCR union UVisObj RD_MBIN *vis, short c);
short processKey(M_D_SCR XPTR rootvisIdx, short c, short ausTopscreen);

void	UVisObj_draw(M_D_SCR union UVisObj RD_MBIN *vis, short redraw);

short UVisObj_update(M_D_SCR union UVisObj RD_MBIN *vis, short redraw);
void initMenuNewSur(M_D_SCR XPTR visIdx);
void setScrOrg(M_D_SCR short x, short y);
void restScrOrg(M_D_SCR_S);

void search_surstring(M_D_SCR DVisAMenu RD_MBIN *def1, RD_char RD_MRAM *wstr);
void search_modstring(M_D_SCR DVisAMenu RD_MBIN *def1, RD_char RD_MRAM *wstr);
void search_elstring(M_D_SCR DVisAMenu RD_MBIN *def1, RD_char RD_MRAM *wstr);
#endif

//******** Funktionspointer fuer kundenspezifische Systemfunktionen

// Editierfunktion fuer alle Elementtypen
typedef short (*E_EDIT)(M_D_SCR CElement RD_MROM *elem, short c);
extern E_EDIT CElement_P_edit_dialog;
extern E_EDIT CElement_P_edit_toggle;
extern E_EDIT CElement_P_edit_dauer;
extern E_EDIT CElement_P_edit_action;
extern E_EDIT CElement_P_edit_focus;

//*** Passwortabfrage
typedef short (*TEST_PWD)(M_D_SCR short level);
extern TEST_PWD RDfp_PasswordTest;

//*** Uhrzeit stellen
typedef short (*STD_CUS_RTC)(M_D_SCR long RD_MRAM *l);
extern STD_CUS_RTC RDfp_SetRtcTime;
extern STD_CUS_RTC RDfp_SetRtcDate;

//*** Warnungsdialoge-ask ok-abfragen
typedef short (*STD_CUS_FUNC)(M_D_SCR_S);
extern STD_CUS_FUNC	RDfp_WarnAskOk;		// "Kritische Funktion"
extern STD_CUS_FUNC RDfp_AskOk1;		// "wirklich speichern"
extern STD_CUS_FUNC RDfp_AskOk2;		// "wirklich ausfuehren"
extern STD_CUS_FUNC RDfp_AskDel;		// "wirklich loeschen"
extern STD_CUS_FUNC RDfp_AskForce;		// "Force aktiv  rcksetzen "

extern STD_CUS_FUNC RDfp_Noteditable;   // "Nicht editierbar"

//*** Diagnose- und Kalibrierfunktionen
extern STD_CUS_FUNC	RDfp_DiagDi;
extern STD_CUS_FUNC	RDfp_DiagDo;
extern STD_CUS_FUNC	RDfp_DiagAi;
extern STD_CUS_FUNC	RDfp_DiagAo;
extern STD_CUS_FUNC	RDfp_DiagCnt;
extern STD_CUS_FUNC	RDfp_KaliAi;
extern STD_CUS_FUNC	RDfp_KaliAo;
extern STD_CUS_FUNC	RDfp_KaliCnt;

//*** Userlabel (Selbstdefinierte Texte fuer Menues und VisTexte)
typedef void (*STD_CUS_UL)(RD_char RD_MRAM *label, RD_char RD_MRAM *retStr);
extern STD_CUS_UL RDfp_getUserLabel;

#if RD_MENUUSERSCROLLBAR != 0
typedef void (*RD_USERSCROLL_FUNC)(M_D_SCR DVisMenuBegin RD_MBIN *thisvis, short itemCount);
extern RD_USERSCROLL_FUNC RDfp_drawUserScrollBar;
#endif // RD_MENUUSERSCROLLBAR != 0
#if RD_MENUUSERCURSOR != 0
typedef void (*RD_USERCURSOR_FUNC)(M_D_SCR DVisMenuBegin RD_MBIN *thisvis);
typedef char (*RD_BELONGSTOUSERCURSOR_FUNC)(DVisMenuBegin RD_MBIN *thisvis, short itemIdx);
extern RD_USERCURSOR_FUNC RDfp_updateUserCursor;
extern RD_BELONGSTOUSERCURSOR_FUNC RDfp_belongsToUserCursor;
#endif // RD_MENUUSERCURSOR != 0
typedef short (*RD_USERCOLUMNCHANGE_FUNC)(DVisMenuBegin RD_MBIN *thisvis, short firstLineInCol);
extern RD_USERCOLUMNCHANGE_FUNC RDfp_changeColumn;

#if NO_EMB_HMI == 0
	//*** global variables also for external use (read only !!!)
	extern short 				RDnumMenu;			// overall number of menu items (of actual menu)
	extern short				RDActLine;			// act. menu iten (not line) relative to top of menu
	extern short				RDActMenuLine;		// act. menu item (not line) relative to top of actual view
	extern short 				RDActValPosX;		// x,y pos of actual focussed element
	extern short				RDActValPosY;
	extern CElement RD_MROM		*RDActElement;		// actual focussed element
	extern DVisSElem RD_MBIN	*RDActVisElem;		// visualizer of current focus element
	extern void RD_MRAM 		*RDActData;			// pointer to the storage adress of RDActElement
	extern short 				RDActIndex;			// RD-index of RDActElement
	extern short RD_MRAM 		*RDpActSurNum;		// auf eine zus. Ablage der aktuellen Surface-Nummer (z.B. ein Element, das die Surfacenummer einblendet)
	extern short 				MenuOrgX, MenuOrgY;

	extern unsigned char		RDexitSurInterpreter;	// Global flag to abort surface interpreter
	
	#ifdef RD_USE_MULTISTEP
		extern unsigned short      RDMultiStep;    // multiplier to the stepwidth for INC/DEC
	#endif

	short DVisGElem_getFormatItem(DVisGElem RD_MBIN *vis, short item);
	short getFormatHEX(void);
	#if RD_PROPFONT == 0
		short CEBin_getMaxSelWidth(CElement RD_MROM *elem, DVisSElem RD_MBIN *vis);
	#endif // RD_PROPFONT == 0
#endif

#if RD_NO_FULL == 0
extern short RDFullOffset;       // zusaetzlicher Offset im VarPool, fuer Visualisierer in einem Full
#if RD_PROPFONT != 0
extern short RDFullPropOffset;   // zusaetzlicher Offset im PropVarPool, fuer Visualisierer in einem Full
#endif // RD_PROPFONT != 0
#endif // RD_NO_FULL == 0

#if RD_UNITCONVERT != 0
	//*** funktionspointer fuer die einheitsumrechnungsfunktion
	typedef long (*E_UNIT_CONV)(CElement RD_MROM *elem, long actval, RD_char RD_MRAM *unit, short *format);
	extern E_UNIT_CONV CElement_P_conv_unit;

	typedef long (*E_UNIT_CONV_REVERSE)(CElement RD_MROM *elem, long actval);
	extern E_UNIT_CONV_REVERSE CElement_P_conv_unit_reverse;
	
	typedef short (*E_STEPWIDTH_CONV)(CElement RD_MROM *elem, short actstepwidth);
	extern E_STEPWIDTH_CONV CElement_P_conv_stepwidth;
	#if RD_USEFLOAT != 0
		typedef void* (*E_UNIT_CONV2)(CElement RD_MROM *elem, void* actval, RD_char RD_MRAM *unit, short *format);
		extern E_UNIT_CONV2 CElement_P_conv_unit2;

		typedef void* (*E_UNIT_CONV_REVERSE2)(CElement RD_MROM *elem, void* actval);
		extern E_UNIT_CONV_REVERSE2 CElement_P_conv_unit_reverse2;
	#endif
#endif



#endif  // _ctr_vis_h_
