#ifndef ___emb_hmi_h___
#define ___emb_hmi_h___

typedef struct
	{
	short screenID;
	short maxlines;
	short maxcolumns;
	short grafikdisp;
	struct S_Modul RD_MROM *startmod;
	//*** startsur darf zur laufzeit nicht veraendert werden weil es fuer den surface reset gebraucht wird
	short	startsur;
	short 	actsur;
	short	ScrOrgX;
	short	ScrOrgY;
	struct S_Surface RD_MROM *actsurface;	//*** aktuelle surface in der screen
	struct S_Modul RD_MROM *actmodul;	//*** aktuelles modul in der screen
	short ActKeyMap;
	#if USE_INSTANCE_ARRAY != 0
	short zugriffsart;
	short zugriffsartMod; //*** zugriffsart des aktuellen moduls
	#endif
	} EMB_HMI;

//*** screen fuer das protokoll
extern EMB_HMI RD_MRAM *G_Protscreen;

//**** defines for format of 1-pixel-data for TTF-font-handling functions
#if (RD_USE_TTFFONTS != 0)
#if BITSPERPIXEL < 16
#error TTF Fonts not supported for this display type
#endif
#if BITSPERPIXEL == 16
#define RD_XCOLOR	unsigned short
#endif
#if BITSPERPIXEL > 16
#define RD_XCOLOR	unsigned long
#endif
#endif

#ifndef ___CTR___
	#include <string>
	using namespace std;
	
	class SurfaceInterpreter
		{
		string startmodul;
		EMB_HMI RD_MRAM *pscreenData;
		SurfaceInterpreter *next;
		public:
			SurfaceInterpreter(RD_CONST char *startmod);
			~SurfaceInterpreter(void);
			void attachScreenData(EMB_HMI *scrData);
			void nextScreenI(SurfaceInterpreter *scrI);
			SurfaceInterpreter *getNext(void) {return(next);};
			EMB_HMI *getScreenData(void) {return(pscreenData);};
			void setModulptr(EMB_HMI *screen);
			void resetScreen(void);
		};
	
	extern SurfaceInterpreter *RootScreenI;
#else
	extern EMB_HMI RD_MRAM *screen;
#endif
#if NO_EMB_HMI == 0
	extern unsigned char fExtRedrawAllTrigger;
	extern unsigned char fExtRedrawPartTrigger;
#endif

#endif